/* --------------------------------------------------------------
          ( 2.1a).
       - .

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2017, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

        " "
     - ,   . 
           . 
          , ,
            
       .
-------------------------------------------------------------- */
#ifndef _CBIGNUMF_INL
#define _CBIGNUMF_INL

#ifndef _CBIGNUMF_H
#include "Cbignumf.h"
#endif//_CBIGNUMF_H

#include <assert.h>
#include <limits.h>
#include <stdlib.h>
#define DISALLOW_EXARRAY_SHORTTYPE
#include "Cbignum.h"
#define BITS    (CHAR_BIT * sizeof (CBNL))

#ifdef  _MSC_VER
#pragma auto_inline (off)
#endif/*_MSC_VER*/

static int count_floor2nBITS()
{
  int n = 2; while (n <= (BITS-1)/2) n <<= 1;
  return (n);
}
static int floor2nBITS = count_floor2nBITS();
static int floor2nBITSm1 = floor2nBITS - 1;

//================================================
//          .
//================================================
//      _addCBNL    (l1,l2,*p)     
//      _adcCBNL  (c,l1,l2,*p)   c 
//      _subCBNL    (l1,l2,*p)     
//      _sbbCBNL  (c,l1,l2,*p)    
//      _muldCBNL   (l1,l2,*p)        
//      _umuldCBNL  (l1,l2,*p)       
//      _ushldCBNL  (ll,lh,sh)      
//      _ushrdCBNL  (ll,lh,sh)      
//      _ushld1CBNL (ll,lh)           
//      _ushrd1CBNL (ll,lh)           
//          .
//      _btCBNL     (num,sh)       
//      _ubsfCBNL   (*p,num)      
//      _ubsrCBNL   (*p,num)      
//            Visual C++

#ifdef  _CBNL_MI

#include <intrin.h>

//   Visual Studio 2005-2012
#ifdef  _CBIGNUM_HARDWARE_CBR
#if     _MSC_VER >= 1800

#ifdef  _M_IX86
#pragma intrinsic(_addcarry_u32)
#pragma intrinsic(_subborrow_u32)
#define _addCBNL(l1,l2,p) _addcarry_u32(0,l1,l2,p)
#define _adcCBNL          _addcarry_u32
#define _subCBNL(l1,l2,p) _subborrow_u32(0,l1,l2,p)
#define _sbbCBNL          _subborrow_u32
#endif//_M_IX86

#ifdef  _M_AMD64
#pragma intrinsic(_addcarry_u64)
#pragma intrinsic(_subborrow_u64)
#define _addCBNL(l1,l2,p) _addcarry_u64(0,l1,l2,p)
#define _adcCBNL          _addcarry_u64
#define _subCBNL(l1,l2,p) _subborrow_u64(0,l1,l2,p)
#define _sbbCBNL          _subborrow_u64
#endif//_M_AMD64

#endif//_MSC_VER
#endif//_CBIGNUM_HARDWARE_CBR

#ifdef  _CBIGNUM_HARDWARE_MUL
#ifdef  _CBNL_MUL
#ifdef  _WIN64
#pragma intrinsic(_mul128)
#pragma intrinsic(_umul128)
#define _muldCBNL   _mul128
#define _umuldCBNL  _umul128
#endif//_WIN64
#endif//_CBNL_MUL
#endif//_CBIGNUM_HARDWARE_MUL

#ifdef  _M_IX86
#if 0 // 
#pragma intrinsic(_bittest)
#define _btCBNL(num,sh)    _bittest((const CBNL *)&(num),(CBNL)(sh))
#endif
#pragma intrinsic(_BitScanForward)
#pragma intrinsic(_BitScanReverse)
#define _ubsfCBNL _BitScanForward
#define _ubsrCBNL _BitScanReverse
#endif//_M_IX86

#ifdef  _WIN64
#pragma intrinsic(__shiftleft128)
#pragma intrinsic(__shiftright128)
#define _ushldCBNL(ll,lh,sh) __shiftleft128(ll,lh,(unsigned char)(sh))
#define _ushrdCBNL(ll,lh,sh) __shiftright128(ll,lh,(unsigned char)(sh))
#if 0 // 
#define _ushld1CBNL(ll,lh)   __shiftleft128(ll,lh,1)
#define _ushrd1CBNL(ll,lh)   __shiftright128(ll,lh,1)
#endif
#if 0 // 
#pragma intrinsic(_bittest64)
#define _btCBNL(num,sh)    _bittest64((const CBNL *)&(num),(CBNL)(sh))
#endif
#pragma intrinsic(_BitScanForward64)
#pragma intrinsic(_BitScanReverse64)
#define _ubsfCBNL _BitScanForward64
#define _ubsrCBNL _BitScanReverse64
#endif//_WIN64

#endif//_CBNL_MI

//================================================
//          .
//================================================

#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus

#ifndef _muldCBNL
CBNL   _CBNL_C  _muldCBNL  (CBNL, CBNL, CBNL*);
#endif

#ifndef _umuldCBNL
unsigned
CBNL   _CBNL_C  _umuldCBNL (unsigned CBNL, unsigned CBNL, unsigned CBNL*);
#endif

#ifdef  __cplusplus
}
#endif//__cplusplus

//================================================
//          ++.
//================================================

#ifndef _addCBNL
inline
unsigned char _addCBNL  (unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  return ((*p = l1 + l2) < l1);
}
#endif

#ifndef _adcCBNL
inline
unsigned char _adcCBNL (unsigned char c,
                        unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  *p = l1 + l2 + c; return (*p < l1 || *p == l1 && c != 0);
}
#endif

#ifndef _subCBNL
inline
unsigned char _subCBNL (unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  return ((*p = l1 - l2) > l1);
}
#endif

#ifndef _sbbCBNL
inline
unsigned char _sbbCBNL (unsigned char c,
                        unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  *p = l1 - l2 - c; return (*p > l1 || *p == l1 && c != 0);
}
#endif

#ifndef _ushldCBNL
inline
unsigned CBNL _ushldCBNL (unsigned CBNL ll, unsigned CBNL lh, unsigned sh)
{
  return ((lh << sh) + (ll >> (BITS-sh)));
}
#endif

#ifndef _ushrdCBNL
inline
unsigned CBNL _ushrdCBNL (unsigned CBNL ll, unsigned CBNL lh, unsigned sh)
{
  return ((ll >> sh) + (lh << (BITS-sh)));
}
#endif

#ifndef _ushld1CBNL
inline
unsigned CBNL _ushld1CBNL (unsigned CBNL ll, unsigned CBNL lh)
{
  return ((lh << 1) + (ll >> (BITS-1)));
}
#endif

#ifndef _ushrd1CBNL
inline
unsigned CBNL _ushrd1CBNL (unsigned CBNL ll, unsigned CBNL lh)
{
  return ((ll >> 1) + (lh << (BITS-1)));
}
#endif

#ifndef _btCBNL
inline
unsigned char _btCBNL (CBNL num, unsigned char sh)
{
  return ((num & ((CBNL)1 << sh)) != 0);
}
#endif

//================================================
//         .
//================================================

#ifdef  _addCBNL
#if 0 // 
#define _USHLD1CBNL(ll,lh) { unsigned CBNL _h;\
                             _adcCBNL (_addCBNL (ll, ll, &ll), lh, lh, &_h);\
                             lh = _h; }
#endif
#if 0 // 
#define _USHLD1CBNL(ll,lh) { lh = lh + lh + _addCBNL (ll, ll, &ll); }
#endif
#endif

#ifndef _USHLD1CBNL
#define _USHLD1CBNL(ll,lh) { lh = _ushld1CBNL (ll, lh); ll += ll; }
#endif

//================================================
//       .
//================================================

inline size_t size_max (size_t n1, size_t n2)
{
  return ((n1 > n2)? n1 : n2);
}

inline size_t size_min (size_t n1, size_t n2)
{
  return ((n1 < n2)? n1 : n2);
}

//================================================
//        ,  "C", 
//        .
//          
//         .
//================================================

#ifdef  NCHECKPTR
#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus
#endif//NCHECKPTR

//================================================
//          cBigNumber.
//================================================
//             CBNL.
//             CBNL-,
//           
//        ,   
//              
//      .      .
//
//            C.
//           EXPTR(CBNL):
//       CBNL*     exptr<CBNL>  
//             .
//           const.
//
//            
//           ;  
//             size_t.
//            ;
//        inline-,  
//          .
//
//         
//        :
//      NDEBUG    -    
//                       
//                     .
//                      
//      NCHECKPTR -    
//                    .
//
//         cBigNumber... 
//       ,      
//         .
//         , 
//          
//       Pentium.

//================================================
//         .
//================================================

cTTY    cBigNumberMessages;             //  .
cTTY    cBigNumberProgress;             //   - .

//           
//          .   
//           ,
//            .
//          .

void    cBigNumberDump (                        //    .
                const   CBPTR(CBNL) p1          //  .
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  for (; n1; n1--) cBigNumberMessages <<" "<< (const char*) cHexDump (p1 [n1]);
  cBigNumberMessages << "\n";
}

//            
//           .
//      the high word followed by total number of words.

void    cBigNumberInfo (                        //  ( ).
                const   CBPTR(CBNL) p1          //  .
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  cBigNumberMessages << cHexDump (n1? p1 [n1]: 0);
  if (n1 > 1)
    cBigNumberMessages << "... (" << (CBNL)(n1 * sizeof (CBNL)) << " bytes)\n";
}

void    cBigNumberERange  (                     //   .
                const   CBPTR(CBNL) p1          //  .
        )
{
  cBigNumberMessages << "cBigNumber value out of range: ";
  cBigNumberInfo (p1);
  abort();
}

//================================================
//       .
//================================================

//          ,  
//               
//          .

size_t  cBigNumberWords (                       //   .
                const   CBPTR(CBNL) p1          //  .
        )                                       // , .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1)
  {
    CBNL sign = p1 [n1] >> (BITS-1);            //  0  -1.
    do
    {
      if (p1 [n1] != sign) break;               //   ?
    }
    while (--n1 != 0);
  }
  return (n1);
}

//              ,
//                
//      . ,  0  -1   , 1  -2 
//      1  ,  127  -128  7  .
//         n     2 
//       n.

int     cLongBits (CBNL num)                    //   
{                                               //   0..BITS-1.
  num ^= (num >> (BITS-1));                     //  .
#ifdef  _ubsrCBNL
  unsigned long n;
  return (_ubsrCBNL (&n, num)? (int)n + 1: 0);
#else //_ubsrCBNL
  int n = 0;
  int k = floor2nBITSm1;                        //  ..31,15,7,3,1.
  do
  {
    int k0 = (((num >> k) == 0) - 1) & (k + 1); num >>= k0; n += k0;
  }
  while ((k >>= 1) != 0);
  return (n += (num > 0));                      //  0.
#endif//_ubsrCBNL
}

//              ,
//        0        .

int     cULongBits (unsigned CBNL num)          //   
{                                               //   0..BITS.
#ifdef  _ubsrCBNL
  unsigned long n;
  return (_ubsrCBNL (&n, num)? (int)n + 1: 0);
#else //_ubsrCBNL
  int n = (((CBNL)num >= 0) - 1); num &= ~n;
      n &= BITS;                                // BITS  .
  int k = floor2nBITSm1;                        //  ..31,15,7,3,1.
  do
  {
    int k0 = (((num >> k) == 0) - 1) & (k + 1); num >>= k0; n += k0;
  }
  while ((k >>= 1) != 0);
  return (n += (num > 0));                      //  0.
#endif//_ubsrCBNL
}

//           .
//         > CBNL_MAX  cBigNumberERange().

CBNL    cBigNumberBits (                        //   .
                const   CBPTR(CBNL) p1          //  .
        )                                       // , .

{
  size_t n = cBigNumberWords(p1);               //   .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n)
  {                                             //  .
    if ((CBNL)n > (CBNL)(CBNL_MAX / BITS))
       cBigNumberERange (p1);
    return ((CBNL)(n - 1) * BITS + cULongBits ((unsigned CBNL)
                                    (p1 [n] ^ (p1 [n1] >> (BITS-1)))));
  }
  return (0);
}

//        0-    ,
//            .
//         ,   0- .

size_t  cBigNumberExWords (                     //   0-.
                const   CBPTR(CBNL) p1          //  .
)                                               // , .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  for (size_t n = 0; n < n1; n++)
  {
    if (p1 [n + 1] != 0) return (n);            //  0-.
  }
  return (0);
}

//        0-    ,
//            .
//      ,  0      0-,
//      2  -2  1  , 128  -128 
//      7  0-.    n 
//      0-   2   n.

int     cLongExBits (CBNL num)                  //   0-
{                                               //   0..BITS-1.
#ifdef  _ubsfCBNL
  unsigned long n;
  return (_ubsfCBNL (&n, num)? (int)n: 0);
#else //_ubsfCBNL
  int n = 0;
  if (num) while ((num & (CBNL)1) == 0) { ++n; num >>= 1; }
  return (n);
#endif //_ubsfCBNL
}

//        0-   .
//          > CBNL_MAX  cBigNumberERange().

CBNL    cBigNumberExBits (                      //   0-.
                const   CBPTR(CBNL) p1          //  .
        )                                       // , .

{
  size_t n = cBigNumberExWords(p1);             //   0-.
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1)
  {                                             //  .
    if ((CBNL)n > (CBNL)((CBNL_MAX - (BITS - 1)) / BITS))
      cBigNumberERange (p1);
    return ((CBNL)n * BITS + cLongExBits (p1 [n + 1]));
  }
  return (0);
}

//            2   n.

int     cLongExactLog2 (CBNL num)               //  log2  -1.
{                                               // log2   0..BITS-1.
  int n = cLongExBits (num);
  if ((num >> n) != 1) n = -1;
  return n;
}

//================================================
//        .
//================================================

//        ,    
//           CBNL-,  
//        :
//      -     1,     
//             ;
//      -     .

size_t _CBNL_C  cBigNumberIsFit (               //  .
                const   CBPTR(CBNL) p1          //  .
        )                                       //   ,
{                                               //   1  0.
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .

  if (n1 > 1) return ((p1 [n1] != (p1 [n1-1] >> (BITS-1))));

  return (n1);                                  //   1  0.
}

//          ,
//          (  1).

size_t _CBNL_C _cBigNumberFit (                 // .
                        EXPTR(CBNL) p1          //   .
        )                                       //   >= 2.
{
  register size_t n1 = (size_t)(*p1);           //  .
  p1 += n1;                                     //  .

  if (n1)                                       //      
  {                                             //   
    register CBNL pass, lp = *p1;               //   0   1, 
    do continue;                                //   .
    while (--n1 != 0 &&
        (pass = lp, lp = p1 [-1], --p1, pass == (lp >> (BITS-1))));
  }                                             //     ,
  else { p1 [1] = 0; }                          //   .

  return (n1 + 1);                              //  .
}
//#define cBigNumberFit(p1)     (size_t)(*(p1)=_cBigNumberFit(p1))

//            
//      .      
//       ,      1.
//
//          .

size_t _CBNL_C _cBigNumberFitTo (               // .
                        EXPTR(CBNL) p1,         //   .
                        size_t      n           //  .
        )                                       //    
{                                               // max (*p1 + 2, n + 1).
  register size_t n1 = (size_t)(*p1);           //  .
  register CBNL pass = p1 [n1] >> (BITS-1);     // .

  do
    p1 [++n1] = pass;                           //  .
  while (n1 < n);

  return (n1);                                  //  .
}
//#define cBigNumberFitTo(p1,n) (size_t)(*(p1)=_cBigNumberFitTo(p1,n))

//================================================
//       .
//================================================

//          
//          .
//           
//             .
//         - , 
//        - .

//           
//          .

int    _CBNL_C  cBigNumberComp (                //  p1, p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2          // .
        )                                       //  -1  p1 <  p2
                                                //   0  p1 == p2
                                                //   1  p1  > p2
{                                               // p1, p2  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //    p1.
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //    p2.
  register CBNL lp1 = 0;                        //   p1.
  register CBNL lp2 = 0;                        //   p2.

//        .

  if (n1) lp1 = p1 [n1--];                      //   p1.
  if (n2) lp2 = p2 [n2--];                      //   p2.

  if (n1 == n2)                                 //  p1, p2 .
  {
    if (lp1 != lp2) goto NotSameSignWord;       //    .
  }
  else if (n1 > n2)                             //   p1 , 
  {                                             //   
    lp2 >>= (BITS-1); ++n2;                     //   p2.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 > n2)                                //   .
    {
      do                                        //  .
      {
        lp1 = p1 [n1]; --n1;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 > n2);                          //   .
    }
  }
  else // (n1 < n2)                             //   p2 , 
  {                                             //   
    lp1 >>= (BITS-1); ++n1;                     //   p1.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 < n2)                                //   .
    {
      do                                        //  .
      {
        lp2 = p2 [n2]; --n2;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 < n2);                          //   .
    }
  }

//         .

  if (n1)
  {
    do                                          //  .
    {
      lp1 = p1 [n1]; lp2 = p2 [n1]; --n1;       //  .
      if (lp1 != lp2) goto NotSame;             //   .
    }
    while (n1);                                 //   .
  }

  return (0);                                   //  .
NotSame:                                        //   .
  return (((unsigned CBNL)lp1 >= (unsigned CBNL)lp2) * 2 - 1);
NotSameSignWord:                                //    .
  return ((lp1 >= lp2) * 2 - 1);
}

//         .
//      , :
//      -  .
//      -        .
//       c       .

int    _CBNL_C  cBigNumberCompHigh (            //    .
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2          // .
        )                                       //  -1  p1 <  p2
                                                //   0  p1 == p2
                                                //   1  p1  > p2
{                                               // p1, p2  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //    p1.
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //    p2.
  assert (n1 >= n2);                            //  .
  assert (n2 > 0);                              //  .

  register CBNL lp1 = p1 [n1--];                //   p1.
  register CBNL lp2 = p2 [n2--];                //   p2.
  assert (!n1 || lp1 != (p1 [n1] >> (BITS-1))); //  .
  assert (!n2 || lp2 != (p2 [n2] >> (BITS-1))); //  .

//        .

  if (lp1 != lp2) return ((lp1 > lp2) * 2 - 1); //   .

//         .

  if (n2)
  do                                            //  .
  {
    lp1 = p1 [n1--]; lp2 = p2 [n2--];           //  .
    if (lp1 != lp2)                             //   .
      return (((unsigned CBNL)lp1 > (unsigned CBNL)lp2) * 2 - 1);
  }
  while (n2);                                   //   .

//         .

  if (n1)
  do
  {
    if (p1 [n1--] != 0) return 1;               // .
  }
  while (n1);

  return (0);                                   //  .
}

//          c 0.
//
//           .
//             ,
//        2 (   
//         ,     > 1).
//
//             0-
//         .

inline
CBNL    cBigNumberNot0  (                       //   0:
                const CBPTR(CBNL) p1_debug      //  0  p1 == 0
                )                               //    0.
{
  const CBNL* p1 = CBPTRBASE(p1_debug);         //  .
  size_t n1 = (size_t)(*p1);                    //  .
  return (p1 [n1] | (*p1 >> 1));
}

//================================================
//         .
//================================================

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//       .
//
//             
//       ,   
//        ,   .

void   _CBNL_C  cBigNumberCopy (                //  p = p1.
                const   CBPTR(CBNL) p1,         //  .
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *CBPTRBASE(p1++));//  .
  if (n1)
  {
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n1 != 0);                          //   .
  }
}

#endif//_CBIGNUM_ASM

//       .
//
//             
//       ,   
//        ,   .

void    cBigNumberCompl (                       //  p = ~p1.
                const   CBPTR(CBNL) p1,         //  .
                        EXPTR(CBNL) p           //  
                                                // max (*p1 + 1, 2).
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *CBPTRBASE(p1++));//  .
  if (n1)
  {
    do                                          //   .
      { *p++ = ~*p1++; }                        //  .
    while (--n1 != 0);                          //   .
  }
  else
  {
    p [-1] = 1; p [0] = ~(CBNL)0;               //  ~0.
  }
}

//================================================
//           .
//================================================

//           ,
//            0.
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShl (                     //  p = p1 << (BITS*k1).
                const   CBPTR(CBNL) p1,         //  .
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                // max (*p1 + k1, 1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1 <= 1 && p1 [n1] == 0) k1 = 0;          //  .
  p1 += n1; *p = (CBNL)(n1 + k1); p += (n1 + k1);
  if (n1)
  do                                            //   .
    { *p-- = *p1--; }                           //  .
  while (--n1 != 0);                            //   .
  if (k1)
  do                                            //   .
    { *p-- = 0; }                               //  .
  while (--k1 != 0);                            //   .
}

//            .
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShr (                     //  p = p1 >> (BITS*k1).
                const   CBPTR(CBNL) p1,         //  .
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                // max (*p1 - k1, 1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1 > k1)
  {
    *p++ = (CBNL)(n1 -= k1);                    //  .
    p1 += (k1 + 1);                             // .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n1 != 0);                          //   .
  }
  else
  {
    *p = 1; p [1] = p1 [n1] >> (BITS-1);        //  0  -1.
  }
}

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//          ,
//       cBigNumberCopyShr() and cBigNumberFitTo().
//
//          2   (BITS * k1).
//           k1,  k1
//           .
//
//         , :
//      -    k1.
//
//          .

void   _CBNL_C  cBigNumberCopyShrToM (          //   
                                                // p = p1 >> (BITS*k1).
                const   CBPTR(CBNL) p1,         //  , *p1 > k1.
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                //   max (k1, *p1 - k1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  assert (n1 > k1);                             //  .
  n1 -= k1;                                     //   .
  p1 += ++k1;                                   // .

  if (k1 <= n1) k1 = n1 + 1;                    //    .
  *p++ = (CBNL) k1;                             //    .
  k1 -= n1;                                     //   .

  register CBNL lp1;
  do
    *p++ = lp1 = *p1++;                         //  .
  while (--n1 != 0);

  lp1 >>= (BITS-1);                             // .
  do
    *p++ = lp1;                                 //  .
  while (--k1 != 0);
}

//          .

void   _CBNL_C  cBigNumberCopyShrUToM (         //   
                                                // p = p1 >> (BITS*k1).
                const   CBPTR(CBNL) p1,         //  , *p1 > k1.
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                //   max (k1, *p1 - k1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  assert (n1 > k1);                             //  .
  n1 -= k1;                                     //   .
  p1 += ++k1;                                   // .

  if (k1 <= n1) k1 = n1 + 1;                    //    .
  *p++ = (CBNL) k1;                             //    ,
  k1 -= n1;                                     //   0-.

  do
    *p++ = *p1++;                               //  .
  while (--n1 != 0);

  do
    *p++ = 0;                                   //  0-.
  while (--k1 != 0);
}

//        ,  ,
//          cBigNumberFitTo().
//
//          .

void   _CBNL_C  cBigNumberClearTo (             //   .
                        EXPTR(CBNL) p1,         //   n + 1.
                        size_t      n           //  .
        )
{
  *p1++ = (CBNL) n;                             //  .
  if (n)
  do
    *p1++ = 0;                                  // .
  while (--n != 0);
}

#endif//_CBIGNUM_ASM

//               0-.
//
//          .

void    cBigNumberCutOut (                      // .
                const   CBPTR(CBNL) p1,         //  .
                        size_t      k1,         //  .
                        size_t      n,          //  .
                        EXPTR(CBNL) p           //   n1 + 1.
        )                                       // p1, p  .
{
  assert ((size_t)(*CBPTRBASE(p1)) >= k1 + n);  //  .
  *p++ = (CBNL)(n + 1);                         //  .
  if (n > 0)                                    //  .
  {
    p1 += (k1 + 1);                             // .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n != 0);                           //   .
  }
  *p = 0;                                       //  .
}

//================================================
//       .
//================================================

//              1.
//      1)        .
//      2)   .
//      3)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t _CBNL_C _cBigNumberNeg (                 //   p = -p1.
                const   CBPTR(CBNL) p1,         //  .
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  p++;
  size_t n = n1;                                //  .
  if (n)
  do                                            //   .
  {
    CBNL lp;                                    //  .
    if ((*p = lp = -*p1) != 0)                  //  .
    {                                           //   .
      if (--n != 0)                             //   ?
      {                                         //   :
        do                                      //  .
          { ++p1; ++p; *p = lp = ~*p1; }        //   .
        while (--n != 0);                       //   .
        return (n1 - (lp == (p [-1] >> (BITS-1))));
      }                                         //   ?
                                                //    , 
      if (lp != CBNL_MIN) return (n1);          //   
      p [1] = 0; return (n1 + 1);               //   .
    }
  }
  while ((++p1, ++p, --n) != 0);                //    .

  return (n1);                                  //   .
}
//#define cBigNumberNeg(p1,p)   (size_t)(*(p)=_cBigNumberNeg(p1,p))

//           .
//
//      :        LONG_MIN
//                        .
//
//           .

void    cBigNumberMNegF (                       //   p1 = -p1.
                        EXPTR(CBNL) p1          //    .
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  if (n1)
  do                                            //   .
  {
    if ((*p1 = -*p1) != 0)                      //  .
    {                                           //   .
      if (--n1 != 0)                            //   ?
      {                                         //   :
        do                                      //  .
          { ++p1; *p1 = ~*p1; }                 //   .
        while (--n1 != 0);                      //   .
      }
      break;
    }
  }
  while ((++p1, --n1) != 0);                    //    .
}

//       1:
//      1)    1     .
//      2)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMInc (                       //  p1 = p1 + 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      CBNL lp;                                  //  .
      if ((*p1 = lp = *p1 + 1) != 0)            //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {                                       //   1 
          if (--n != 0) return (n1);            //   ,  .
          return (n1 - (p1 [1] == (lp >> (BITS-1))));
        }                                       //    , 
        if (lp != CBNL_MIN) return (n1);        //   
        p1 [1] = 0; return (n1 + 1);            //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = 1; n1 = 1; }                     //   .

  return (n1);                                  //   .
}
//#define cBigNumberMInc(p1)    (size_t)(*(p1)=_cBigNumberMInc(p1))

//       1:
//      1)    1    ,   ~0.
//      2)    ,     011..(),
//            .
//               00..  011..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDec (                       //  p1 = p1 - 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      CBNL lp;                                  //  .
      if ((*p1 = lp = *p1 - 1) != ~(CBNL)0)     //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {                                       //   1 
          if (--n != 0) return (n1);            //   ,  .
          return (n1 - (p1 [1] == (lp >> (BITS-1))));
        }                                       //    , 
        if (lp != CBNL_MAX) return (n1);        //   
        p1 [1] = ~(CBNL)0; return (n1 + 1);     //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = -1; n1 = 1; }                    //   .

  return (n1);                                  //   .
}
//#define cBigNumberMDec(p1)    (size_t)(*(p1)=_cBigNumberMDec(p1))

//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMMul2 (                      //  p1 <<= 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .
  CBNL num = 0;                                 //   .
  if (n)
  do                                            //   .
  {
    CBNL pass = (unsigned CBNL)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2(p1)   (size_t)(*(p1)=_cBigNumberMMul2(p1))

//          .

size_t  _cBigNumberMul2 (                       //  p = p1 << 1.
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  p++;
  CBNL num = 0;                                 //   .
  size_t n = n1;                                //  .

  if (n)
  do                                            //   .
  {
    CBNL pass = (unsigned CBNL)num >> (BITS-1); //    .
    num = *p1++;                                //    .
    *p++ = (num << 1) | pass;                   //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p = num >> 1));               //  .

  return (n1);                                  //  .
}
//#define cBigNumberMul2(p1,p)  (size_t)(*(p)=_cBigNumberMul2(p1,p))

//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDiv2 (                      //  p1 >>= 1.
                        EXPTR(CBNL) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .

  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      CBNL num = *p1;                           //    .
      n1 -= (num == (*p1-- = (num >> 1)));      //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        CBNL pass = num << (BITS-1);            //    .
        num = *p1;                              //    .
        *p1-- = ((unsigned CBNL)num >> 1) | pass;
      }                                         //    .
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      (*p1) >>= 1;                              // .
    }
  }
  return (n1);                                  //  .
}
//#define cBigNumberMDiv2(p1)   (size_t)(*(p1)=_cBigNumberMDiv2(p1))

//          .

size_t  _cBigNumberDiv2 (                       //  p = p1 << 1.
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .
  p  += n;                                      //  .

  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      CBNL num = *p1--;                         //    .
      n1 -= (num == (*p-- = (num >> 1)));       //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        CBNL pass = num << (BITS-1);            //    .
        num = *p1--;                            //    .
        *p-- = ((unsigned CBNL)num >> 1) | pass;//    .
      }
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      *p = (*p1) >> 1;                          // .
    }
  }
  return (n1);                                  //  .
}
//#define cBigNumberDiv2(p1,p)  (size_t)(*(p)=_cBigNumberDiv2(p1,p))

//================================================
//        .
//================================================

//       ,       
//          1..BITS-1   *p + 2.
//           
//       ;    
//          .
//            
//      ,   .

void    cBigNumberTab (                         //   .
                        EXPTR(CBNL) p           //    
        )                                       // (max(*p,1) + 2) * BITS + 1.
                                                //   
{                                               // p << 1..BITS-1,  *p + 2.
  size_t n = cBigNumberFit (p);                 //   .
  int ns = BITS - 1;                            //   .
  p [n + 1] = p [n] >> (BITS-1);                //  .
  n += 2;
  EXPTR(CBNL) pp = p;                           //  .
  do                                            //  .
  {
    pp += n;
    cBigNumberMul2 (p, pp);                     //    .
    p = pp;
  }
  while (--ns > 0);                             //    .
}

//================================================
//       .
//================================================

//          
//          .
//         .
//
//       :
//      - ,      .
//      -      
//            .
//
//             
//       ,   ,   
//          -     .

size_t  _cBigNumberXor  (                       //  mod2 p = p1 ^ p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // ,  0 .

  {
    register CBNL lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ ^ (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ ^ lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register CBNL pass;                         //  .
    register CBNL lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberXor(p1,p2,p) (size_t)(*(p)=_cBigNumberXor(p1,p2,p))

size_t  _cBigNumberAnd  (                       //  p = p1 & p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // ,  0 .

  {
    register CBNL lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ & (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ & lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register CBNL pass;                         //  .
    register CBNL lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAnd(p1,p2,p) (size_t)(*(p)=_cBigNumberAnd(p1,p2,p))

size_t  _cBigNumberOr  (                        //  p = p1 & p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // ,  0 .

  {
    register CBNL lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ | (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ | lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register CBNL pass;                         //  .
    register CBNL lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberOr(p1,p2,p)  (size_t)(*(p)=_cBigNumberOr(p1,p2,p))

//================================================
//         .
//================================================

//          
//          .
//         ()  
//        ()     .
//
//       :
//      - ,      .
//      -      
//            .
//
//             
//       ,   ,   
//          -     .

size_t  _cBigNumberAdd  (                       //  p = p1 + p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // Return if 0 words.

  register unsigned CBNL pass = 0;              //     p.
        //      pass
        // unsigned CBNL   pass >>   .
  {
    register CBNL lp1 = 0;                      //   p1.
    register CBNL lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = *p2++;
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const CBNL *pp = p1;           // .
        if ((lp2 & CBNL_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register CBNL lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (CBNL)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (CBNL)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAdd(p1,p2,p) (size_t)(*(p)=_cBigNumberAdd(p1,p2,p))

//           :
//            .

size_t  _cBigNumberSub  (                       //  p = p1 - p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // Return if 0 words.

  unsigned CBNL pass = ~(unsigned CBNL)0;       //     p.
        //      pass
        // unsigned CBNL   pass >>   .
        //     .
  {
    register CBNL lp1 = 0;                      //   p1.
    register CBNL lp2 = ~(CBNL)0;               //   ~p2.

//        p1, ~p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = ~(*p2++);
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const CBNL *pp = p1;           // .
        if ((lp2 & CBNL_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2~.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register CBNL lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (CBNL)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (CBNL)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSub(p1,p2,p) (size_t)(*(p)=_cBigNumberSub(p1,p2,p))

//         .

size_t  _cBigNumberSubS (                       //  p = p2 - p1.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // Return if 0 words.

  unsigned CBNL pass = ~(unsigned CBNL)0;       //     p.
        //      pass
        // unsigned CBNL   pass >>   .
        //     .
  {
    register CBNL lp1 = ~(CBNL)0;               //   ~p1.
    register CBNL lp2 = 0;                      //   p2.

//        ~p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = ~(*p1++); lp2 = *p2++;
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const CBNL *pp = p1;           // .
        if ((lp2 & CBNL_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          ~p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register CBNL lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (CBNL)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (CBNL)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSubS(p1,p2,p) (size_t)(*(p)=_cBigNumberSubS(p1,p2,p))

//================================================
//        .
//================================================


//        0- + 1 (, ).

#ifndef _CBIGNUM_MT
static  size_t  _cBigNumberSkip = 1;            //  0- + 1.
#else //_CBIGNUM_MT
#define _cBigNumberSkip 1
#endif//_CBIGNUM_MT

//         0-.

size_t _CBNL_C  cBigNumberSkipLow0 (            //  0-.
                const   CBPTR(CBNL) p1          //   .
)                                               //   0- + 1.
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n = 1;                                 //  0- + 1.

  if (n1 != 0)
  do
  {
    if (p1 [n] != 0) break;                     //   .
    n++;
  }
  while (--n1 != 0);

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = n;                          //  0- + 1.
#endif//_CBIGNUM_MT

  return (n);                                   //  0- + 1.
}

//               .
//
//          ,  
//       ,    0.
//
//        0,    ,  
//         0  0    0.

size_t _CBNL_C  cBigNumberCopySkipLow0 (        //  p = p1 >> exwords(p1).
                const   CBPTR(CBNL) p1,         //   .
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p  .
                                                //   0-.
{
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .

//      .

  if (n1)                                       //      
  {                                             //   
    CBNL pass, lp = p1 [n1];                    //   0   1, 
    do continue;                                //   .
    while (--n1 != 0 &&
        (pass = lp, lp = p1 [n1], pass == (lp >> (BITS-1))));
    ++n1; ++p1;

//        0-  .

    size_t k1 = 0;                              //   0-.
    do                                          //  0-.
    {
      if (p1 [k1] != 0)                         //   .
      {
        p1 += k1;                               // .
        *p++ = (CBNL)n1;                        //  .
        do                                      //   .
          { *p++ = *p1++; }                     //  .
        while (--n1 != 0);                      //   .
        return (k1);                            //   0-.
      }
      k1++;                                     //   0-
    }
    while (--n1 != 0);
  }

//         0  0 ,    .

  *p = 0;                                       //   0
  return (0);                                   //  0 .
}

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//           
//          .   .
//
//         , :
//      -     ,    
//            ,   .
//      -       0.
//           cBigNumberSkipLow0()
//          0-   .
//
//          ,  
//             .

void   _CBNL_C  cBigNumberMAddM (               //  p1 += p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  const CBPTR(CBNL) pp = p1 + (size_t)(*p1);    //   p1.
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  register unsigned CBNL pass = 0;              // : 0  1.
        // unsigned CBNL   pass >>   .
  {
    const CBPTR(CBNL) ppn = p1 + n2;            //    p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register CBNL lp1;                          //   p1.
    register CBNL lp2;                          //   p2.

//        p1, p2.
//          :
//      pass = ((~(*p1 = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
//                                                       | (lp1 & lp2))
//            :
//      pass += (lp1 + lp2)     // *p1 = pass
//      lp1  = ~(lp1 ^ lp2)     //  lp1  .
//      pass = ~(pass | lp1)    //    
//      pass |= (lp1 & lp2)     //   a & b = ~(a^b) & b.
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass += lp2;      lp1 = ~lp1;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= ppn)    break;
      ++p1;             pass >>= (BITS-1);
    }
    if ((CBNL)(lp2 ^= pass) >= 0) return;       //    .
  }

//           p1,  p1  p2.
//      : p1     ,
//                   pass     .

  {
    register CBNL lp1;                          //   p1.
    if ((CBNL)pass < 0)                         // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

//           
//          .   .
//
//         , :
//      -     ,    
//            ,   .
//      -       0.
//           cBigNumberSkipLow0()
//          0-   .
//
//          ,  
//             .

void   _CBNL_C  cBigNumberMSubM (               //  p1 -= p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  const CBPTR(CBNL) pp = p1 + (size_t)(*p1);    //   p1.
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  register CBNL pass = 0;                       // : 0  1.
        // CBNL   pass >>   .
  {
    const CBPTR(CBNL) ppn = p1 + n2;            //    p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register CBNL lp1;                          //   p1.
    register CBNL lp2;                          //   p2.

//        p1, p2.
//          :
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//            :
//      pass += (lp1 - lp2)     // *p1 = pass
//      pass |= (lp1 ^= lp2)    //  lp1  .
//      pass = ~pass;           //    
//      pass |= (lp1 & ~lp2)    //   a & ~b = (a^b) & ~b.
//      pass = ~pass;
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= ppn)    break;
      ++p1;             pass >>= (BITS-1);
                        pass = ~pass;
    }
    if ((CBNL)(lp2 ^= pass) >= 0) return;       //    .
  }

//           p1,  p1  p2.
//      : p1     ,
//                   pass     .

  {
    register CBNL lp1;                          //   p1.
    if ((CBNL)pass < 0)                         // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

//           
//         .   .
//
//         , :
//      -    .
//      -     ,    
//         .
//      -       0.
//      -        .
//      -      ,
//           .
//           cBigNumberSkipLow0()
//          0-  .
//
//            
//        .

size_t _CBNL_C _cBigNumberMSubD (               //  p1 -= p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((p1 [(size_t)(*p1)] ^ p2 [n2]) >= 0); //  .
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  register CBNL pass = 0;                       // : 0  -1.
        // CBNL   pass >>   .
  {
    const CBPTR(CBNL) ppn = p1 + n2;            //    p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register CBNL lp1;                          //   p1.
    register CBNL lp2;                          //   p2.

//        p1, p2.
//          :
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//            :
//      pass += (lp1 - lp2)     // *p1 = pass
//      pass |= (lp1 ^= lp2)    //  lp1  .
//      pass &=~(lp1 & ~lp2)    //    
//                              //   a & ~b = (a^b) & ~b.
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       lp2 &= lp1;
      if (p1 >= ppn)    break;
      lp2 = ~lp2;       pass |= lp1;
      ++p1;             pass &= lp2;
      ++p2;             pass >>= (BITS-1);
    }
  }

//       -     p,   0  1
//             .
//      : p1     ,
//                       pass.

  {
    register size_t n1 = n2 + k2;

//         :
//      do continue;
//      while (--n1 != 0 &&
//              lp1 == (lp1 = pass, pass = p1 [-1], --p1, pass >> (BITS-1)));

    for (;;)
    {
      register CBNL lp1;                        //  .
      register CBNL lp2;                        //  .
      if (--n1 == 0)    break;                  //   .
      lp2 = p1 [-1];    --p1;
      lp1 = pass;       pass = lp2;
      lp2 >>= (BITS-1);
      if (lp1 != lp2)   break;
    }
    return (n1 + 1);                            //   p.
  }
}
//#define cBigNumberMSubD(p1,p2,k2) (size_t)(*(p1)=_cBigNumberMSubD(p1,p2,k2))

//          1 .
//        .
//
//      ,     0.
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t _CBNL_C _cBigNumberMMul2M (              //  p1 <<= 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert (n1 >= _cBigNumberSkip);               //  .

  const CBPTR(CBNL) pp = p1 + n1;               //   p1.
  p1 += _cBigNumberSkip;                        //    p1.
  CBNL num = 0;                                 //   .
  do                                            //   .
  {
    CBNL pass = (unsigned CBNL)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (p1 <= pp);                             //   .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2M(p1)   (size_t)(*(p1)=_cBigNumberMMul2M(p1))

//          1 .
//            .
//
//      , :
//      -    0.
//      -      .
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t _CBNL_C _cBigNumberMDiv2D (              //  p1 >>= 1.
                        EXPTR(CBNL) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert (n1 >= _cBigNumberSkip);               //  .
  assert ((p1 [_cBigNumberSkip] & (CBNL)1)==0); //   .

  const CBPTR(CBNL) pp = p1 + _cBigNumberSkip;  //    p1.
  p1 += n1;                                     //  .
  CBNL num = *p1;                               //    .
  n1 -= (n1 > 1) & (num == (*p1-- = num >> 1)); //     
                                                // ,  0  ~0.
  while (p1 >= pp)                              //   .
  {
    CBNL pass = num << (BITS-1);                //    .
    num = *p1;                                  //    .
    *p1-- = ((unsigned CBNL)num >> 1) | pass;   //    .
  }                                             //    .

  return (n1);                                  //  .
}
//#define cBigNumberMDiv2D(p1)   (size_t)(*(p1)=_cBigNumberMDiv2D(p1))

#endif//_CBIGNUM_ASM

//              .
//         ,  ,  .

void    cBigNumberMShrM (                       //  p1 >>= BITS.
                        EXPTR(CBNL) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 1);                              // .
  *p1 = (CBNL)--n1;
  do                                            //   .
    { p1 [1] = p1 [2]; p1++; }                  //  .
  while ((CBNL)--n1 > 0);                       //   .
}

//             .
//         ,  ,  .

void    cBigNumberMShlD (                       //  p1 <<= BITS.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 0);                              // .
  *p1 = (CBNL)(n1 + 1);
  do                                            //   .
    { p1 [n1 + 1] = p1 [n1]; }                  //  .
  while ((CBNL)--n1 > 0);                       //   .
  p1 [1] = 0;
}

//          ,  
//       ,     .
//
//             
//       .

void    cBigNumberMAddShl (                     //  p1 += p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  
                                                //   
                                                // max (*p1, *p2 + k2) + 2.
                const   CBPTR(CBNL) p2,         // .
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p1, n2 + k2 + 1);            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
  if (n2 > 0) cBigNumberMAddM (p1, p2, k2);     //  .

  cBigNumberFit (p1);                           // .
}

void    cBigNumberMSubShl (                     //  p1 -= p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  
                                                //   
                                                // max (*p1, *p2 + k2) + 2.
                const   CBPTR(CBNL) p2,         // .
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p1, n2 + k2 + 1);            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
  if (n2 > 0) cBigNumberMSubM (p1, p2, k2);     //  .

  cBigNumberFit (p1);                           // .
}

//================================================
//       ,  
//         .
//================================================

//            .
//            , 
//       cBigNumberTab().  ,  
//            _CBNL_KARATSUBA_MIN * 2.
//            
//       ,       _CBNL_TAB_OPT.
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShlTab (               //   
                                                // p += p1 *p2 << k*BITS.
                const   CBPTR(CBNL) p1,         //    .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//          .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    n1 += 2;                                    //   .
#ifndef _CBIGNUM_TERNARY_MUL
    for (size_t k2 = 0; k2 != n2; k2++)         //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = 1;                            //    num.
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (;; pp1 += n1)                        //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }                                           //     p2.
#else //_CBIGNUM_TERNARY_MUL
    CBNL num2 = p2 [n2], num1 = num2;           //    .
    num2 <<= 1;                                 //  .
    CBNL mode = 0;                              // 0=, -1=.
    if ((num1 & num2) < 0)                      //    1.
    {
      cBigNumberMAddM (p, p1, k + n2);          //    n2.
      num1 = ~num1; num2 = ~num2;
      mode = ~(CBNL)0;                          //  .
    }
    p1 += n1 * BITS; p1 -= n1;                  //  .
    for (size_t k2 = n2; k2-- != 0;)            //    p2.
    {
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (size_t kb = BITS;; pp1 -= n1)        //     p2.
      {
        CBNL num = num1;                        //  .
        num1 = num2;                            // 1-  .
        if (kb != 2) num2 <<= 1;                // 2-  .
        else num2 = (k2? p2 [k2]: 0L) ^ mode;   //  .
        if ((num | (num1 & num2) ) < 0)         //  .
        {
           if (mode == 0) cBigNumberMAddM (p, pp1, k + k2);
           else           cBigNumberMSubM (p, pp1, k + k2);
           if (num >= 0) { num1 = ~num1; num2 = ~num2; mode = ~mode; }
        }                                       //  .
        if (--kb == 0) break;                   //  .
      }                                         //     p2.
    }                                           //     p2.
#endif//_CBIGNUM_TERNARY_MUL
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

void    cBigNumberMSubMulShlTab (               //   
                                                // p -= p1 *p2 << k*BITS.
                const   CBPTR(CBNL) p1,         //    .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//          .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    n1 += 2;                                    //   .
#ifndef _CBIGNUM_TERNARY_MUL
    for (size_t k2 = 0; k2 != n2; k2++)         //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = 1;                            //    num.
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (;; pp1 += n1)                        //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }                                           //     p2.
#else //_CBIGNUM_TERNARY_MUL
    CBNL num2 = p2 [n2], num1 = num2;           //    .
    num2 <<= 1;                                 //  .
    CBNL mode = 0;                              // 0=, -1=.
    if ((num1 & num2) < 0)                      //    1.
    {
      cBigNumberMSubM (p, p1, k + n2);          //    n2.
      num1 = ~num1; num2 = ~num2;
      mode = ~(CBNL)0;                          //  .
    }
    p1 += n1 * BITS; p1 -= n1;                  //  .
    for (size_t k2 = n2; k2-- != 0;)            //    p2.
    {
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (size_t kb = BITS;; pp1 -= n1)        //     p2.
      {
        CBNL num = num1;                        //  .
        num1 = num2;                            // 1-  .
        if (kb != 2) num2 <<= 1;                // 2-  .
        else num2 = (k2? p2 [k2]: 0L) ^ mode;   //  .
        if ((num | (num1 & num2) ) < 0)         //  .
        {
           if (mode == 0) cBigNumberMSubM (p, pp1, k + k2);
           else           cBigNumberMAddM (p, pp1, k + k2);
           if (num >= 0) { num1 = ~num1; num2 = ~num2; mode = ~mode; }
        }                                       //  .
        if (--kb == 0) break;                   //  .
      }                                         //     p2.
    }                                           //     p2.
#endif//_CBIGNUM_TERNARY_MUL
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//================================================
//       ,  
//       ,   ,
//         ,
//         .
//================================================

#if !defined (_CBIGNUM_HARDWARE_MUL) || !defined (_CBNL_MUL)

//            .
//       c,      .
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShl (                  //   
                                                // p += p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3.
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//       ,    .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      if (num == 0) continue;                   // .
      CBNL mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     //  .
    }                                           //     p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  p2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

void    cBigNumberMSubMulShl (                  //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3.
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//       ,    .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      if (num == 0) continue;                   // .
      CBNL mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     //  .
    }                                           //     p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  p2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//            .
//             
//       ,      .
//           
//         .
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShlKar (               //   
                                                // p += p1 *p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3 +
                                                // *p2 < _CBNL_TAB_MIN?
                                                //  (min (*p1, _CBNL_TAB_HIGH)
                                                //   + 2) * (BITS - 1).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        1-   .
//      :    p2   .

    while (n1 > n2 * 2 - n2 / 4)                //  .
    {
      CBNL lp = p1 [n1 -= n2];                  //  
      p1 [n1] = (CBNL) n2;                      //    .
      cBigNumberMAddMulShlKar (p1 + n1, p2, k + n1, p);
      p1 [n1] = lp;                             //  .
      p1 [n1 + 1] = 0; n1 += (lp < 0);          //   0-.
      p1 [0] = (CBNL) n1;                       //   .
    }

//            .

    size_t n = (n1 >= n2? n1: n2 - 1) / 2;      //   .

//      :     p   
//                  ,  p1   p2   ,
//                    p2      p2.

    cBigTemp c12; c12.checkexpand (n * 2 + 5);
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

    cBigTemp c1; c1.checkexpand (n + 2);
    cBigTemp c2; c2.checkexpand (n + 4);
    cBigNumberCopyShr (p2, n, EXPTRTYPE(c2));   //   p2  c2.

//       p1   n    p1     p2.
//      :    c2   .

    if (n1 > n)
    {
      cBigNumberCopyShr (p1, n, EXPTRTYPE(c1)); //   p1  c1.
      CBNL lp = p1 [n];                         //  
      p1 [n] = (CBNL)(n1 - n);                  //    .
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1 + n, EXPTRTYPE(c2), 0, p12);
                                                //  c1 * c2.
      cBigNumberMAddShl (p, p12, k + n * 2);    //  c1 * c2.
      cBigNumberMSubShl (p, p12, k + n);        //  c1 * c2.
      p1 [n] = lp;                              //  .
      p1 [n + 1] = 0;                           //   0-.
      p1 [0] = (CBNL)(n + (lp < 0));            //   p1.
      cBigNumberMAddShl (EXPTRTYPE(c1), p1, 0); //  c1 + p1.
    }
    else
      cBigNumberCopy (p1, EXPTRTYPE(c1));       //  p1  c1.

//       p2    n  .

    assert (n2 > n);
    {
      size_t nc2 = c2.length() + 1;             //   0-.
      c2.item (0) = (CBNL) nc2;
      ((EXPTR(CBNL)) EXPTRTYPE(c2)) [nc2] = 0;

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      p2 [0] = (CBNL)(n + 1);                   //   p2.
      cBigNumberMAddShl (EXPTRTYPE(c2), p2, 0); //  c2 + p2.
      p2 [n + 1] = lp;                          //  .

      p2 [0] = (CBNL) n;                        //   0-.
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1, p2, 0, p12); //  p1 * p2.
      p2 [0] = (CBNL) n2;                       //   p2.

      c2.item (0) = (CBNL)(c2.length() - (c2.hiword() == 0));
                                                //   0-.
      cBigNumberCopy (CBPTRTYPE(c1), p1);       //  (c1+p2)*(c2+p2).
      cBigNumberMAddMulShlKar (p1, EXPTRTYPE(c2), k + n, p);

      cBigNumberMSubShl (p, p12, k + n);        //  p1 * p2.
      cBigNumberMAddShl (p, p12, k);            //  p1 * p2.
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       1-   ,  2-  .
//
//            ,  
//        ,      0-.
//           _CBNL_TAB_OPT + 1 ,
//        0-     , 
//           _CBNL_TAB_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n1 > _CBNL_TAB_HIGH)
  {                                             //   
    --n1;                                       //  .
    do                                          //   .
    {
      n1 -= _CBNL_TAB_OPT;                      //    .
      CBNL lp = p1 [n1];                        //  
      p1 [n1] = _CBNL_TAB_OPT + 1;              //    .
#ifdef  _CBIGNUM_SHIFTTAB_MUL
      if (n2 >= _CBNL_TAB_MIN) {                //   ?
        cBigNumberTab (p1 + n1);                //   .
        cBigNumberMAddMulShlTab (p1 + n1, p2, k + n1, p);
      } else
#endif//_CBIGNUM_SHIFTTAB_MUL
        cBigNumberMAddMulShl (p1 + n1, p2, k + n1, p);
      p1 [n1 + 1] = 0;                          //   0-.
      p1 [n1] = lp;                             //  .
    }
    while (n1 >= _CBNL_TAB_HIGH);
    p1 [0] = (CBNL)(n1 + 1);                    //   .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

#ifdef  _CBIGNUM_SHIFTTAB_MUL
#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 >= _CBNL_TAB_MIN) {                    //   ?
#else
  if (n2 >= _CBNL_TAB_MIN && n1 <= _CBNL_TAB_HIGH) {
#endif//_CBIGNUM_BLOCK_MUL
    cBigNumberTab (p1);                         //   .
    cBigNumberMAddMulShlTab (p1, p2, k, p);
  } else
#endif//_CBIGNUM_SHIFTTAB_MUL
    cBigNumberMAddMulShl (p1, p2, k, p);
}

void    cBigNumberMSubMulShlKar (               //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3 +
                                                // *p2 < _CBNL_TAB_MIN?
                                                //  (min (*p1, _CBNL_TAB_HIGH)
                                                //   + 2) * (BITS - 1).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        1-   .
//      :    p2   .

    while (n1 > n2 * 2 - n2 / 4)                //  .
    {
      CBNL lp = p1 [n1 -= n2];                  //  
      p1 [n1] = (CBNL) n2;                      //    .
      cBigNumberMSubMulShlKar (p1 + n1, p2, k + n1, p);
      p1 [n1] = lp;                             //  .
      p1 [n1 + 1] = 0; n1 += (lp < 0);          //   0-.
      p1 [0] = (CBNL) n1;                       //   .
    }

//            .

    size_t n = (n1 >= n2? n1: n2 - 1) / 2;      //   .

//      :     p   
//                  ,  p1   p2   ,
//                    p2      p2.

    cBigTemp c12; c12.checkexpand (n * 2 + 5);
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

    cBigTemp c1; c1.checkexpand (n + 2);
    cBigTemp c2; c2.checkexpand (n + 4);
    cBigNumberCopyShr (p2, n, EXPTRTYPE(c2));   //   p2  c2.

//       p1   n    p1     p2.
//      :    c2   .

    if (n1 > n)
    {
      cBigNumberCopyShr (p1, n, EXPTRTYPE(c1)); //   p1  c1.
      CBNL lp = p1 [n];                         //  
      p1 [n] = (CBNL)(n1 - n);                  //    .
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1 + n, EXPTRTYPE(c2), 0, p12);
                                                //  c1 * c2.
      cBigNumberMSubShl (p, p12, k + n * 2);    //  c1 * c2.
      cBigNumberMAddShl (p, p12, k + n);        //  c1 * c2.
      p1 [n] = lp;                              //  .
      p1 [n + 1] = 0;                           //   0-.
      p1 [0] = (CBNL)(n + (lp < 0));            //   p1.
      cBigNumberMAddShl (EXPTRTYPE(c1), p1, 0); //  c1 + p1.
    }
    else
      cBigNumberCopy (p1, EXPTRTYPE(c1));       //  p1  c1.

//       p2    n  .

    assert (n2 > n);
    {
      size_t nc2 = c2.length() + 1;             //   0-.
      c2.item (0) = (CBNL) nc2;
      ((EXPTR(CBNL)) EXPTRTYPE(c2)) [nc2] = 0;

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      p2 [0] = (CBNL)(n + 1);                   //   p2.
      cBigNumberMAddShl (EXPTRTYPE(c2), p2, 0); //  c2 + p2.
      p2 [n + 1] = lp;                          //  .

      p2 [0] = (CBNL) n;                        //   0-.
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1, p2, 0, p12); //  p1 * p2.
      p2 [0] = (CBNL) n2;                       //   p2.

      c2.item (0) = (CBNL)(c2.length() - (c2.hiword() == 0));
                                                //   0-.
      cBigNumberCopy (CBPTRTYPE(c1), p1);       //  (c1+p2)*(c2+p2).
      cBigNumberMSubMulShlKar (p1, EXPTRTYPE(c2), k + n, p);

      cBigNumberMAddShl (p, p12, k + n);        //  p1 * p2.
      cBigNumberMSubShl (p, p12, k);            //  p1 * p2.
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       1-   ,  2-  .
//
//            ,  
//        ,      0-.
//           _CBNL_TAB_OPT + 1 ,
//        0-     , 
//           _CBNL_TAB_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n1 > _CBNL_TAB_HIGH)
  {                                             //   
    --n1;                                       //  .
    do                                          //   .
    {
      n1 -= _CBNL_TAB_OPT;                      //    .
      CBNL lp = p1 [n1];                        //  
      p1 [n1] = _CBNL_TAB_OPT + 1;              //    .
#ifdef  _CBIGNUM_SHIFTTAB_MUL
      if (n2 >= _CBNL_TAB_MIN) {                //   ?
        cBigNumberTab (p1 + n1);                //   .
        cBigNumberMSubMulShlTab (p1 + n1, p2, k + n1, p);
      } else
#endif//_CBIGNUM_SHIFTTAB_MUL
        cBigNumberMSubMulShl (p1 + n1, p2, k + n1, p);
      p1 [n1 + 1] = 0;                          //   0-.
      p1 [n1] = lp;                             //  .
    }
    while (n1 >= _CBNL_TAB_HIGH);
    p1 [0] = (CBNL)(n1 + 1);                    //   .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

#ifdef  _CBIGNUM_SHIFTTAB_MUL
#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 >= _CBNL_TAB_MIN) {                    //   ?
#else
  if (n2 >= _CBNL_TAB_MIN && n1 <= _CBNL_TAB_HIGH) {
#endif//_CBIGNUM_BLOCK_MUL
    cBigNumberTab (p1);                         //   .
    cBigNumberMSubMulShlTab (p1, p2, k, p);
  } else
#endif//_CBIGNUM_SHIFTTAB_MUL
    cBigNumberMSubMulShl (p1, p2, k, p);
}

//             .
//             
//          .
//
//           
//         .
//
//             
//       .

void    cBigNumberMAddMul (                     //   
                                                // p += p1 * p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
}

void    cBigNumberMSubMul (                     //   
                                                // p -= p1 * p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
}

void    cBigNumberMul (                         //  p = p1 * p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //  
                                                // *p1 + *p2 + 3.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

//        -    cBigNumberMul()
//       cBigNumberMAddMul().     
//      ,    .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    p [0] = 0;                                  //  .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    p [0] = 0;                                  //  .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
}

//================================================
//         
//        ().
//================================================

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//          CBNL   .

#ifndef _muldCBNL
CBNL   _CBNL_C  _muldCBNL (                     //  p = p1 * p2.
                        CBNL    l1,             // .
                        CBNL    l2,             // .
                        CBNL    *p              //   .
        )                                       //   
{                                               // .
  CBNL c1 [5]; c1 [0] = 1; c1 [1] = l1;         //   .
  CBNL c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  CBNL c  [5]; c [0] = c [1] = c [2] = 0;       //   .
  EXPTR(CBNL) pp1 = EXPTRTO(CBNL,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(CBNL) pp2 = EXPTRTO(CBNL,c2,sizeof(c2)/sizeof(*c2)-1);
  EXPTR(CBNL) pp  = EXPTRTO(CBNL,c, sizeof(c) /sizeof(*c) -1);

  if (l2 >= 0)                                  //  :
    cBigNumberMAddMulShl (pp1, pp2, 0, pp);     // .
  else {                                        //  :
    c2 [1] = -l2;                               //  .
    cBigNumberMSubMulShl (pp1, pp2, 0, pp);     // .
  }

  *p = c [2];
  return c [1];
}
#endif//_muldCBNL

//           CBNL   .

#ifndef _umuldCBNL
unsigned
CBNL   _CBNL_C  _umuldCBNL (                    //  l1 * l2.
                unsigned CBNL   l1,             //  .
                unsigned CBNL   l2,             //  .
                unsigned CBNL   *p              //   .
        )                                       //   
{                                               // .
  CBNL c1 [5]; c1 [0] = 2; c1 [1] = l1; c1 [2] = 0;
                                                //   .
  CBNL c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  CBNL c  [6]; c [0] = c [1] = c [2] = 0;       //   .
  EXPTR(CBNL) pp1 = EXPTRTO(CBNL,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(CBNL) pp2 = EXPTRTO(CBNL,c2,sizeof(c2)/sizeof(*c2)-1);
  EXPTR(CBNL) pp  = EXPTRTO(CBNL,c, sizeof(c) /sizeof(*c) -1);

  cBigNumberMAddMulShl (pp1, pp2, 0, pp);       // .

  *p = c [2];
  return c [1];
}
#endif//_umuldCBNL

#endif//_CBIGNUM_ASM

#else //_CBIGNUM_HARDWARE_MUL && _CBNL_MUL

//================================================
//         .
//================================================

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//           
//             long
//              .
//
//         ,   ,
//      ..   ,   .
//
//         , :
//      -        
//            ,   .
//      -       0.
//
//          ,  , 
//            ,
//         .    
//       ,     .

void   _CBNL_C  cBigNumberMAddMulM  (           //  p1+=p2*l2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //  .
                     unsigned CBNL  l2,         //  .
                            size_t  k2          //   .
        )                                       // p1, p2   .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  assert ((size_t)(*p1) > n2 + k2);             //  .
  assert (n2 > 0);                              //  .
  assert (p1 != p2);                            //  .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

  cBigTemp c; c.checkexpand (n2 + 2);           //   
  EXPTR(CBNL) p = EXPTRTYPE(c);                 //  .
  {
    size_t k = 1;
    do                                          //     p2.
      p [k] = _umuldCBNL (p2 [k], l2,
                         (unsigned CBNL*)EXPTRINDEX(p + k + 1,0));
    while ((k += 2) <= n2);                     //     p2.
    p [k] = 0; p [0] = (CBNL) k;
    cBigNumberMAddM (p1, p, k2);
  }
  if (n2 > 1)
  {
    size_t k = 1;
    do                                          //     p2.
      p [k] = _umuldCBNL (p2 [k + 1], l2,
                         (unsigned CBNL*)EXPTRINDEX(p + k + 1,0));
    while ((k += 2) < n2);                      //     p2.
    p [k] = 0; p [0] = (CBNL) k;
    cBigNumberMAddM (p1, p, k2 + 1);
  }
}

void   _CBNL_C  cBigNumberMSubMulM  (           //  p1-=p2*l2<<k2*BITS
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //  .
                     unsigned CBNL  l2,         //  .
                            size_t  k2          //   .
        )                                       // p1, p2   .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  assert ((size_t)(*p1) > n2 + k2);             //  .
  assert (n2 > 0);                              //  .
  assert (p1 != p2);                            //  .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

  cBigTemp c; c.checkexpand (n2 + 2);           //   
  EXPTR(CBNL) p = EXPTRTYPE(c);                 //  .
  {
    size_t k = 1;
    do                                          //     p2.
      p [k] = _umuldCBNL (p2 [k], l2,
                         (unsigned CBNL*)EXPTRINDEX(p + k + 1,0));
    while ((k += 2) <= n2);                     //     p2.
    p [k] = 0; p [0] = (CBNL) k;
    cBigNumberMSubM (p1, p, k2);
  }
  if (n2 > 1)
  {
    size_t k = 1;
    do                                          //     p2.
      p [k] = _umuldCBNL (p2 [k + 1], l2,
                         (unsigned CBNL*)EXPTRINDEX(p + k + 1,0));
    while ((k += 2) < n2);                      //     p2.
    p [k] = 0; p [0] = (CBNL) k;
    cBigNumberMSubM (p1, p, k2 + 1);
  }
}

#endif//_CBIGNUM_ASM

//             
//          .  ,  
//            _CBNL_KARATSUBA_MIN * 4.
//            
//       ,       _CBNL_MUL_HIGH.
//
//       ,   ,
//      ..   ,   .
//
//          ,  , 
//            ,
//         .    
//       ,     .

void   _CBNL_C  cBigNumberMAddMulShlM (         //   
                                                // p += p1 * p2 << k*BITS.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 1 -
                                                //          (p1 [*p1] == 0));
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//      Algorithm with hardware multiplication.

  if (n1 != 0 && n2 != 0)                       //  ?
  {
    CBNL lp1 = *p1++;                           //   p1.

    if (--n1 != 0)
    do                                          //    p1.
    {
      if (lp1 != 0) cBigNumberMAddMulM (p, p2, lp1, k);
      lp1 = *p1++; k++;                         //   p1.
    }
    while (--n1 != 0);                          //     p1.

    if (lp1 > 0)                                //  .
      cBigNumberMAddMulM (p, p2, lp1, k);
    else if (lp1 < 0)                           //  .
      cBigNumberMSubMulM (p, p2, -lp1, k);
  }
}

void   _CBNL_C  cBigNumberMSubMulShlM (         //   
                                                // p -= p1 * p2 << k*BITS.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 1 -
                                                //          (p1 [*p1] == 0));
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//      Algorithm with hardware multiplication.

  if (n1 != 0 && n2 != 0)                       //  ?
  {
    CBNL lp1 = *p1++;                           //   p1.

    if (--n1 != 0)
    do                                          //    p1.
    {
      if (lp1 != 0) cBigNumberMSubMulM (p, p2, lp1, k);
      lp1 = *p1++; k++;                         //   p1.
    }
    while (--n1 != 0);                          //     p1.

    if (lp1 > 0)                                //  .
      cBigNumberMSubMulM (p, p2, lp1, k);
    else if (lp1 < 0)                           //  .
      cBigNumberMAddMulM (p, p2, -lp1, k);
  }
}

//        ,     
//          .
//
//      :      ,
//                    p1 ,   ,  
//                      - .  .

void    cBigNumberMAddMulShl (                  //   
                                                // p += p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
                                                // **  p1  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p, n1 + n2 + k + 1);         // .
  cBigNumberMAddMulShlM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

void    cBigNumberMSubMulShl (                  //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
                                                // **  p1  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p, n1 + n2 + k + 1);         // .
  cBigNumberMSubMulShlM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

//           
//           .
//           
//         .
//
//       ,   ,
//      ..   ,   .
//
//          ,  , 
//            ,
//         .    
//       ,     .

void   _CBNL_C  cBigNumberMAddMulShlKarM (      //   
                                                // p += p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 2.
        )                                       // p1,p2,p   .
                                                //   *p1, *p2.
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
#ifdef  _CBIGNUM_KARATSUBA_MUL
  size_t n1 = (size_t)(*p1);                    //  .
#endif//_CBIGNUM_KARATSUBA_MUL
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        2-   .
//      :     p1  
//                  .  *p1  .

    while (n2 > n1 * 2 - n1 / 4)                //  .
    {
      CBNL lp = p2 [n2 -= n1];                  //  .
      p2 [n2] = (CBNL) n1;                      //  .
      cBigNumberMAddMulShlKarM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
      p2 [0] = (CBNL) n2;                       //   .
      p1 [0] = (CBNL) n1;                       //   p1.
    }

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

//            .
//      :     p1  p2  
//                  .  *p1  *p2  .

    assert ((size_t)(*p) >= n1 + n2 + k);       //  .
    size_t n = (n1 > n2? n1 - 1: n2) / 2;       //   .

//       p1    n  .
//       p2   n    p2     p1.
//      :     p   
//                  ,  p2   p1   ,
//                    p1      p1.

    cBigTemp c12; c12.checkexpand (n * 2 + 6);  //   .
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

//        p1 *  p2,   p2 +  p2.
//      : p1  p2  ,   *p2.

    assert (n1 > n);
    if (n2 > n)
    {
      CBNL lp1 = p1 [n];                        //  .
      CBNL lp2 = p2 [n];                        //  .
      p1 [n] = (CBNL)(n1 -= n);                 //  .
      p2 [n] = (CBNL)(n2 -= n);                 //  .
      cBigNumberClearTo (p12, n1 + n2 + 2);     //   .
      cBigNumberMAddMulShlKarM (p1 + n, p2 + n, 0, p12);
                                                //   p1 * p2.
      --*EXPTRBASE(p12);                        //  .
      cBigNumberMAddM (p, p12, k + n * 2);      //   p1 * p2.
      cBigNumberMSubM (p, p12, k + n);          //   p1 * p2.
      p1 [n] = lp1;                             //  .
      p2 [n] = lp2;                             //  .

      cBigNumberCopyShrUToM (p2, n, p12);       //   p2.

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p2) = (CBNL)(n + 1);           //   p2.
      cBigNumberMAddM (p12, p2, 0);             //  + p2.
      *EXPTRBASE(p2) = (CBNL) n;                //   0-.
      n2 = n;                                   //   .
      p2 [n + 1] = lp;                          //  .

      size_t n12 = (size_t)(*EXPTRBASE(p12));   //  .
      while (p12 [n12] == 0 && --n12 != 0) continue;
      *EXPTRBASE(p12) = (CBNL) n12;             //   0-.
    }
    else
      cBigNumberCopy (p2, p12);                 //  p2.

//       ( p1 +  p1) * ( p2 +  p2) 
//                   p1 *  p2.
//      : p1  p2  ,   *p1  *p2.

    {
      cBigNumberCopyShrToM (p1, n, p12 + n + 3);//   p1.
      CBNL lp = p1 [n + 1];                     //  .
      p1 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p1) = (CBNL)(n + 1);           //   p1.
      cBigNumberMAddM (p12 + n + 3, p1, 0);     //  + p1.
      cBigNumberFit (p12 + n + 3);              // .

      cBigNumberMAddMulShlKarM (p12 + n + 3, p12, k + n, p);
                                                //   p1 * p2.

      cBigNumberClearTo (p12, n + n2 + 3);      //   .
      cBigNumberMAddMulShlKarM (p1, p2, 0, p12);//   p1 * p2.
      (*EXPTRBASE(p12)) -= 2;                   //  .
      cBigNumberMSubM (p, p12, k + n);          //   p1 * p2.
      cBigNumberMAddM (p, p12, k);              //   p1 * p2.

      p1 [n + 1] = lp;                          //  .
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       2-   ,  1-  .
//
//            ,  
//        ,      0-.
//           _CBNL_MUL_OPT + 1 ,
//        0-     , 
//           _CBNL_MUL_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 > _CBNL_MUL_HIGH)
  {
    do                                          //   .
    {
      n2 -= _CBNL_MUL_OPT + 1;                  //    .
      CBNL lp = p2 [n2];                        //  .
      p2 [n2] = _CBNL_MUL_OPT + 1;              //   .
      cBigNumberMAddMulShlM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
    }
    while (n2 >= _CBNL_MUL_HIGH);
    p2 [0] = (CBNL) n2;                         //    .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

  cBigNumberMAddMulShlM (p1, p2, k, p);
}

void   _CBNL_C  cBigNumberMSubMulShlKarM (     //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 2.
        )                                       // p1,p2,p   .
                                                //   *p1, *p2.
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
#ifdef  _CBIGNUM_KARATSUBA_MUL
  size_t n1 = (size_t)(*p1);                    //  .
#endif//_CBIGNUM_KARATSUBA_MUL
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        2-   .
//      :     p1  
//                  .  *p1  .

    while (n2 > n1 * 2 - n1 / 4)                //  .
    {
      CBNL lp = p2 [n2 -= n1];                  //  .
      p2 [n2] = (CBNL) n1;                      //  .
      cBigNumberMSubMulShlKarM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
      p2 [0] = (CBNL) n2;                       //   .
      p1 [0] = (CBNL) n1;                       //   p1.
    }

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

//            .
//      :     p1  p2  
//                  .  *p1  *p2  .

    assert ((size_t)(*p) >= n1 + n2 + k);       //  .
    size_t n = (n1 > n2? n1 - 1: n2) / 2;       //   .

//       p1    n  .
//       p2   n    p2     p1.
//      :     p   
//                  ,  p2   p1   ,
//                    p1      p1.

    cBigTemp c12; c12.checkexpand (n * 2 + 6);  //   .
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

//        p1 *  p2,   p2 +  p2.
//      : p1  p2  ,   *p2.

    assert (n1 > n);
    if (n2 > n)
    {
      CBNL lp1 = p1 [n];                        //  .
      CBNL lp2 = p2 [n];                        //  .
      p1 [n] = (CBNL)(n1 -= n);                 //  .
      p2 [n] = (CBNL)(n2 -= n);                 //  .
      cBigNumberClearTo (p12, n1 + n2 + 2);     //   .
      cBigNumberMAddMulShlKarM (p1 + n, p2 + n, 0, p12);
                                                //   p1 * p2.
      --*EXPTRBASE(p12);                        //  .
      cBigNumberMSubM (p, p12, k + n * 2);      //   p1 * p2.
      cBigNumberMAddM (p, p12, k + n);          //   p1 * p2.
      p1 [n] = lp1;                             //  .
      p2 [n] = lp2;                             //  .

      cBigNumberCopyShrUToM (p2, n, p12);       //   p2.

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p2) = (CBNL)(n + 1);           //   p2.
      cBigNumberMAddM (p12, p2, 0);             //  + p2.
      *EXPTRBASE(p2) = (CBNL) n;                //   0-.
      n2 = n;                                   //   .
      p2 [n + 1] = lp;                          //  .

      size_t n12 = (size_t)(*EXPTRBASE(p12));   //  .
      while (p12 [n12] == 0 && --n12 != 0) continue;
      *EXPTRBASE(p12) = (CBNL) n12;             //   0-.
    }
    else
      cBigNumberCopy (p2, p12);                 //  p2.

//       ( p1 +  p1) * ( p2 +  p2) 
//                   p1 *  p2.
//      : p1  p2  ,   *p1  *p2.

    {
      cBigNumberCopyShrToM (p1, n, p12 + n + 3);//   p1.
      CBNL lp = p1 [n + 1];                     //  .
      p1 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p1) = (CBNL)(n + 1);           //   p1.
      cBigNumberMAddM (p12 + n + 3, p1, 0);     //  + p1.
      cBigNumberFit (p12 + n + 3);              // .

      cBigNumberMSubMulShlKarM (p12 + n + 3, p12, k + n, p);
                                                //   p1 * p2.

      cBigNumberClearTo (p12, n + n2 + 3);      //   .
      cBigNumberMAddMulShlKarM (p1, p2, 0, p12);//   p1 * p2.
      (*EXPTRBASE(p12)) -= 2;                   //  .
      cBigNumberMAddM (p, p12, k + n);          //   p1 * p2.
      cBigNumberMSubM (p, p12, k);              //   p1 * p2.

      p1 [n + 1] = lp;                          //  .
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       2-   ,  1-  .
//
//            ,  
//        ,      0-.
//           _CBNL_MUL_OPT + 1 ,
//        0-     , 
//           _CBNL_MUL_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 > _CBNL_MUL_HIGH)
  {
    do                                          //   .
    {
      n2 -= _CBNL_MUL_OPT + 1;                  //    .
      CBNL lp = p2 [n2];                        //  .
      p2 [n2] = _CBNL_MUL_OPT + 1;              //   .
      cBigNumberMSubMulShlM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
    }
    while (n2 >= _CBNL_MUL_HIGH);
    p2 [0] = (CBNL) n2;                         //    .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

  cBigNumberMSubMulShlM (p1, p2, k, p);
}

//        ,     
//          .
//
//      :      Cbignumf.inl  ,
//                       
//                  ,  p1   ,   
//                     - .   Cbignumf.inl.

void    cBigNumberMAddMulShlKar (               //   
                                                // p += p1 *p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
                                                // **   *p1, *p2.

{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigNumberFitTo (p, n1 + n2 + k + 2);         // .
  cBigNumberMAddMulShlKarM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

void    cBigNumberMSubMulShlKar (               //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
                                                // **   *p1, *p2.
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigNumberFitTo (p, n1 + n2 + k + 2);         // .
  cBigNumberMSubMulShlKarM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

//            ,
//          .
//      .    Cbignumf.inl.
//
//          
//          ,  p2.

void    cBigNumberMAddMul (                     //   
                                                // p += p1 * p2.
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand (n1);                    //  .
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  cBigNumberFitTo (p, n1 + n2 + 2);             // .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMAddMulShlKarM (pp1, pp2, k, p);  //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMSubMulShlKarM (pp1, pp2, k, p);  //  .
  }

  cBigNumberFit (p);                            // .
}

void    cBigNumberMSubMul (                     //   
                                                // p -= p1 * p2.
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand (n1);                    //  .
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  cBigNumberFitTo (p, n1 + n2 + 2);             // .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMSubMulShlKarM (pp1, pp2, k, p);  //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMAddMulShlKarM (pp1, pp2, k, p);  //  .
  }

  cBigNumberFit (p);                            // .
}

void    cBigNumberMul (                         //  p = p1 * p2.
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //  
                                                // *p1 + *p2 + 3.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand (n1);                    //  .
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

//        -    cBigNumberMul()
//       cBigNumberMAddMul().     
//      ,    .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberClearTo (p, n1 + n2 + 2);         //   .
    cBigNumberMAddMulShlKarM (pp1, pp2, k, p);  //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberClearTo (p, n1 + n2 + 2);         //   .
    cBigNumberMSubMulShlKarM (pp1, pp2, k, p);  //  .
  }

  cBigNumberFit (p);                            // .
}

#endif//_CBIGNUM_HARDWARE_MUL && _CBNL_MUL

//================================================
//      ,    0.
//================================================

size_t  cBigNumberMaskDiv0;                     //    0:
                                                //  0 - Divide Error
void    cBigNumberDiv0()                        // >0 - 
{
  cBigNumberMaskDiv0 /= cBigNumberMaskDiv0;
}

//================================================
//        .
//================================================

//           .
//      ,       ,
//             0.
//            ,
//        cBigNumberTab.
//
//              .
//       >= 0.      .
//         0,   ,   0,
//        .
//
//         .
//           .

void    cBigNumberMModDivShlTab (               // 
                                                // p = p1 / p2 << k2*BITS,
                                                //    p1 %= p2 << k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //    .
                        size_t      k2,         //   .
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1,p2,p   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1; n = n1 - n + 1;           //    .

//              ,
//             .
//          ,    
//       .

  *p = (CBNL)(n + 1); p += n; p [1] = 0;        //   p.

//             .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0-.
  {                                             //    0.
    assert ((p1 [n1] ^ CBPTRBASE(p2)[n2]) >= 0);//  .
    CBNL lt = (CBPTRBASE(p2)[n2] < 0) * 2 - 1;  //   
                                                //   .
                                                // (p1  p2 >= 0)? -1: 1
    n2 += 2;                                    //   .
    do                                          //    .
    {
      --n;                                      //   .
      p2 += n2 * BITS;                          //    .
      unsigned CBNL mask = ((unsigned CBNL)1)   //  .
                            << (BITS-1);
      *p = 0;                                   //   .
      do                                        //    .
      {
        p2 -= n2;                               //  .
        CBNL diff = (CBNL)(n + k2) - *p1 + *p2; //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, p2) != lt)) //  ,
        {                                       //  
          cBigNumberMSubD (p1, p2, n + k2);     //   
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p;                                      //   .
    }
    while (n);                                  //    .
    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    do { *p-- = 0; } while (--n);               //   
  }                                             //    0.

  cBigNumberFit (p);                            //  .
  assert (p [(size_t)(*p)] >= 0);               //  .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//              
//            .
//         ,      
//      ,   ,    .
//
//              .
//        -      .
//           .
//         0,   ,   0,
//        .
//
//         .
//           .

void    cBigNumberMModDiv (                     //  p = p1 / p2,
                                                //         p1 %= p2.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //   *p1 + 3.
        )                                       // p2    p1, p.
{
  assert (p1 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//        ,    .

#ifdef  _CBIGNUM_SMALL_DIV
  unsigned CBNL p2h = 0;                        //    0.
  if (n1 && n2 == 1) p2h = CBPTRBASE(p2)[1];

//            .

  if (p2h == 0)                                 //    
  {                                             //   .
#endif//_CBIGNUM_SMALL_DIV
    cBigTemp cBigBuf2;                          //   .
#ifdef  _CBIGNUM_SHIFTTAB_DIV
    CBNL nt = (CBNL)((n2 - n1 + _CBNL_TAB_MIN - 1) & (n2 - _CBNL_TAB_MAX));
    cBigBuf2.checkexpand ((size_t)((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3)));
#else //_CBIGNUM_SHIFTTAB_DIV
    cBigBuf2.checkexpand ((size_t)(n2 + 3));
#endif//_CBIGNUM_SHIFTTAB_DIV
    EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);      //   .

//              0-.
//        0,    0 .

    size_t k2 = cBigNumberCopySkipLow0 (p2, pp2);

//           .

    CBNL signquot = p1 [n1] ^ CBPTRBASE(p2)[n2];//   .
    if (signquot < 0) cBigNumberNeg (pp2, pp2); //   .

//          .

#ifdef  _CBIGNUM_SHIFTTAB_DIV
    if (nt < 0)
    {
      cBigNumberTab (pp2);                      //   .
      cBigNumberMModDivShlTab (p1, pp2, k2, p); // .
      if (signquot < 0) cBigNumberNeg (p, p);   //   .
      return;
    }
#endif//_CBIGNUM_SHIFTTAB_DIV

//       ,    .

    n2 = (size_t)(*pp2);                        //  .
    if (n2 == 0)                                //  0.
    {                                           //    0
      cBigNumberDiv0();                         // ,  
      p [0] = 1; p [1] = 0;                     //   
      return;                                   //    0.
    }
    assert (cBigNumberIsFit (p1));              //  .
    assert (cBigNumberIsFit (pp2));             //  .

    size_t n = n2 + k2;                         //    .
    if (n1 < n)                                 //   
    {                                           // ,  
      p [0] = 1; p [1] = 0;                     //   
      return;                                   //    0.
    }

//              ,
//             .
//          ,    
//       .

    n = n1 - n + 1;                             //    .
    *p = (CBNL)(n + 1); p += n; p [1] = 0;      //   p.

//             .

    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    CBNL lt = (pp2 [n2] < 0) * 2 - 1;           //   
                                                //   
                                                // (p1  pp2 >= 0)? -1: 1
    do                                          //    .
    {
      --n;                                      //   .
      *p = 0;                                   //   .
      cBigNumberMShlD (pp2);                    //    .
      unsigned CBNL mask = ((unsigned CBNL)1)   //  .
                            << (BITS-1);
      do                                        //    .
      {
        CBNL diff = (CBNL)cBigNumberMDiv2D (pp2)//    .
                  + (CBNL)(n + k2) - *p1;       //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n + k2);    //   
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p;                                      //   .
    }
    while (n);                                  //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, pp2) == lt);    //   .
    assert (cBigNumberIsFit (p1));              //  .
    cBigNumberFit (p);                          //  .

    assert (p [(size_t)(*p)] >= 0);             //  .
    if (signquot < 0) cBigNumberNeg (p, p);     //   .
#ifdef  _CBIGNUM_SMALL_DIV
    return;
  }

//           .
//          .

  unsigned CBNL p1h = p1 [n1];                  //   .
  CBNL signquot = p1h ^ p2h;                    //  .
  if ((CBNL)p2h < 0) p2h = -(CBNL)p2h;          //  .
  assert (p2h > 0 && p2h <= (unsigned CBNL)(CBNL_MIN));

//            .

  if (n1 > 1)                                   //  ,
  {                                             //  .
    if ((CBNL)p1h < 0) { cBigNumberMNegF (p1);  //  .
                         p1 [0] = p1h;          //  .
                         p1h = p1 [n1]; }       //   .
    assert (p1h <= (unsigned CBNL)(CBNL_MIN));  //  .

//              ,
//             .
//          ,    
//       .

    *p = (CBNL)(n1 + 1); p += n1; p [1] = 0;    //   p.

//             .

    *p = 0;                                     //   .

//             :
//      -         0,
//        .. -LONG_MIN  ,    - .
//      -        
//         0,   -LONG_MIN   .

    int nb1 = BITS - 1 - cULongBits (p1h);      //   .
    int nb2 = BITS - 1 - cLongBits (p2h);       //    
    p2h <<= nb2;                                //  .
    int nb = nb2 - nb1;                         //   .
    if (nb < 0) {                               //    ,
      *--p = 0; nb += BITS;                     //    .
    }                                           //  .
    unsigned CBNL mask = ((unsigned CBNL)1) << nb;
    unsigned CBNL p1l = 0;                      //   .
    if (nb1 > 0)                                //    
    {                                           //   0-.
      p1l = p1 [--n1];                          //   .
      p1h = _ushldCBNL (p1l, p1h, nb1);         //    
      p1l <<= nb1; nb1 -= BITS;                 //     .
    }                                           //    
    else if (nb1 < 0) p1h >>= 1;                //  -LONG_MIN
    for (;;)                                    //    .
    {
      if (p1h >= p2h)                           //    
      {                                         //  ,
        p1h -= p2h; (*p) += mask;               //    
      }                                         //   .
      if (++nb1 > 0)                            //  .
      {
        if (--n1 == 0) break;                   //   .
        p1l = p1 [n1]; nb1 -= BITS;             //   .
      }
      _USHLD1CBNL (p1l, p1h);                   //   .
      if (!(mask >>= 1))                        //   .
      {                                         //   ,
        *--p = 0;                               //   .
        mask = ((unsigned CBNL)1) << (BITS-1);  //  .
      }
    }                                           //    .

//          .

    unsigned CBNL pn = *p;                      //   .
#ifdef  _CBIGNUM_HARDWARE_DIV
    if (nb2 >= _CBNL_HARDDIV_BITS)              //   
    {                                           //   0-.
      p2h >>= nb2;                              //  .
      unsigned CBNL pl = p1h / p2h;             // .
      pn |= pl; p1h -= pl * p2h;                //   .
    }
    else                                        //  .
#endif//_CBIGNUM_HARDWARE_DIV
    while ((p2h >>= 1, mask >>= 1) != 0)        //    .
    if (p1h >= p2h)                             //    
    {                                           //  ,
      p1h -= p2h; pn += mask;                   //    
    }                                           //   .
    assert ((CBNL)p1h >= 0);                    //  .
    if (p1 [0] >= 0) p1 [1] = p1h;              //  .
    else             p1 [1] = -(CBNL)p1h;       //   .
    p1 [0] = 1;                                 //    .

    *p-- = pn;                                  //   .
    cBigNumberFit (p);                          //  .
    assert (p [(size_t)(*p)] >= 0);             //  .
    if (signquot < 0) cBigNumberNeg (p, p);     //   .
    return;
  }

//           .

  {
    if ((CBNL)p1h < 0) p1h = -(CBNL)p1h;        //  .
    assert (p1h <= (unsigned CBNL)(CBNL_MIN));  //  .

    unsigned CBNL pn;                           // .
#ifdef  _CBIGNUM_HARDWARE_DIV
    pn = p1h / p2h; p1h -= pn * p2h;            //   .
#else //_CBIGNUM_HARDWARE_DIV
    pn = 0;                                     //  .
    unsigned CBNL mask = ((unsigned CBNL)1);    //  .
    int nb = cULongBits (p1h) - cULongBits (p2h);
    if (nb >= 0)                                //  ,  
    {                                           //     >= 0.
      mask <<= nb; p2h <<= nb;                  //  .
      do                                        //    .
      if (p1h >= p2h)                           //    
      {                                         //  ,
        p1h -= p2h; pn += mask;                 //    
      }                                         //   .
      while ((p2h >>= 1, mask >>= 1) != 0);     //    .
    }
#endif//_CBIGNUM_HARDWARE_DIV
    assert ((CBNL)p1h >= 0);                    //  .
    if (p1 [1] >= 0) p1 [1] = p1h;              //  .
    else             p1 [1] = -(CBNL)p1h;       //   .

    if (signquot >= 0)
    if ((CBNL)pn >= 0)
         { p [0] = 1; p [1] = pn; }             //  .
    else { p [0] = 2; p [1] = pn; p [2] = 0; }  //  CBNL_MIN/-1  .
    else { p [0] = 1; p [1] = -(CBNL)pn; }      //   .
    assert (cBigNumberIsFit (p));               //  .
  }
#endif//_CBIGNUM_SMALL_DIV
}

//================================================
//        .
//================================================

//           .
//      ,       ,
//             0.
//            ,
//        cBigNumberTab.
//
//           
//       ,     .
//           .
//           .
//         0,   ,   .
//
//         .
//         .

void    cBigNumberMModShlTab (                  //  p1 %= p2<< k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //    .
                        size_t      k2          //   .
        )                                       // p1, p2   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p2);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1; n = n1 - n + 1;           //  .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0-.
  {                                             //    0.
    assert ((p1 [n1] ^ CBPTRBASE(p2)[n2]) >= 0);//  .
    CBNL lt = (CBPTRBASE(p2)[n2] < 0) * 2 - 1;  //   
                                                //   
                                                // (p1  p2 >= 0)? -1: 1
    n2 += 2;                                    //   .
    do                                          //   .
    {
      --n;                                      //  .
      p2 += n2 * BITS;                          //    .
      unsigned CBNL mask = ((unsigned CBNL)1)   //  .
                            << (BITS-1);
      do                                        //   .
      {
        p2 -= n2;                               //  .
        CBNL diff = (CBNL)(n + k2) - *p1 + *p2; //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, p2) != lt)) //  ,
        {                                       //  
          cBigNumberMSubD (p1, p2, n + k2);     //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
    }
    while (n);                                  //    .
    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
  }                                             //   .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//              
//            .
//         ,      
//      ,   ,    .
//
//           
//       ,     .
//           .
//           .
//         0,   ,   .
//
//         .
//         .

void    cBigNumberMMod (                        //  p1 %= p2.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2          // .
        )                                       // p1, p2  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//        ,    .

#ifdef  _CBIGNUM_SMALL_DIV
  unsigned CBNL p2h = 0;                        //    0.
  if (n1 && n2 == 1) p2h = CBPTRBASE(p2)[1];

//            .

  if (p2h == 0)                                 //    
  {                                             //   .
#endif//_CBIGNUM_SMALL_DIV
    cBigTemp cBigBuf2;                          //   .
#ifdef  _CBIGNUM_SHIFTTAB_DIV
    CBNL nt = (CBNL)((n2 - n1 + _CBNL_TAB_MIN - 1) & (n2 - _CBNL_TAB_MAX));
    cBigBuf2.checkexpand ((size_t)((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3)));
#else //_CBIGNUM_SHIFTTAB_DIV
    cBigBuf2.checkexpand ((size_t)(n2 + 3));
#endif//_CBIGNUM_SHIFTTAB_DIV
    EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);      //   .

//              0-.
//        0,    0 .

    size_t k2 = cBigNumberCopySkipLow0 (p2, pp2);

//           .

    if ((p1 [n1] ^ CBPTRBASE(p2)[n2]) < 0) cBigNumberNeg (pp2, pp2);

//          .

#ifdef  _CBIGNUM_SHIFTTAB_DIV
    if (nt < 0)
    {
      cBigNumberTab (pp2);                      //   .
      cBigNumberMModShlTab (p1, pp2, k2);       // .
      return;
    }
#endif//_CBIGNUM_SHIFTTAB_DIV

//       ,    .

    n2 = (size_t)(*pp2);                        //  .
    if (n2 == 0)                                //  0.
    {                                           //    0
      cBigNumberDiv0();                         // ,  
      return;                                   //   .
    }
    assert (cBigNumberIsFit (p1));              //  .
    assert (cBigNumberIsFit (pp2));             //  .

    size_t n = n2 + k2;                         //    .
    if (n1 < n) return;                         //    
                                                //    .
    n = n1 - n + 1;                             //  .

    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    CBNL lt = (pp2 [n2] < 0) * 2 - 1;           //   
                                                //   
                                                // (p1  pp2 >= 0)? -1: 1
    do                                          //   .
    {
      --n;                                      //  .
      cBigNumberMShlD (pp2);                    //    .
      unsigned CBNL mask = ((unsigned CBNL)1)   //  .
                            << (BITS-1);
      do                                        //   .
      {
        CBNL diff = (CBNL)cBigNumberMDiv2D (pp2)//    .
                  + (CBNL)(n + k2) - *p1;       //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n + k2);    //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
    }
    while (n);                                  //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, pp2) == lt);    //   .
    assert (cBigNumberIsFit (p1));              //  .
#ifdef  _CBIGNUM_SMALL_DIV
    return;
  }

//           .
//          .

  unsigned CBNL p1h = p1 [n1];                  //   .
  if ((CBNL)p2h < 0) p2h = -(CBNL)p2h;          //  .
  assert (p2h > 0 && p2h <= (unsigned CBNL)(CBNL_MIN));

//            .

  if (n1 > 1)                                   //  ,
  {                                             //  .
    if ((CBNL)p1h < 0) { cBigNumberMNegF (p1);  //  .
                         p1 [0] = p1h;          //  .
                         p1h = p1 [n1]; }       //   .
    assert (p1h <= (unsigned CBNL)(CBNL_MIN));  //  .

//             :
//      -         0,
//        .. -LONG_MIN  ,    - .
//      -        
//         0,   -LONG_MIN   .

    int nb1 = BITS - 1 - cULongBits (p1h);      //   .
    int nb2 = BITS - 1 - cLongBits (p2h);       //    
    p2h <<= nb2;                                //  .
    unsigned CBNL p1l = 0;                      //   .
    if (nb1 > 0)                                //    
    {                                           //   0-.
      p1l = p1 [--n1];                          //   .
      p1h = _ushldCBNL (p1l, p1h, nb1);         //    
      p1l <<= nb1; nb1 -= BITS;                 //     .
    }                                           //    
    else if (nb1 < 0) p1h >>= 1;                //  -LONG_MIN
    for (;;)                                    //   .
    {
      if (p1h >= p2h)                           //    
      {                                         //  ,
        p1h -= p2h;                             //   .
      }
      if (++nb1 > 0)                            //  .
      {
        if (--n1 == 0) break;                   //   .
        p1l = p1 [n1]; nb1 -= BITS;             //   .
      }
      _USHLD1CBNL (p1l, p1h);                   //   .
    }                                           //    .

//          .

#ifdef  _CBIGNUM_HARDWARE_DIV
    if (nb2 >= _CBNL_HARDDIV_BITS)              //   
    {                                           //   0-.
      p2h >>= nb2;                              //  .
      p1h %= p2h;                               // .
    }
    else                                        //  .
#endif//_CBIGNUM_HARDWARE_DIV
    while ((p2h >>= 1, --nb2) >= 0)             //   .
    if (p1h >= p2h)                             //    
    {                                           //  ,
      p1h -= p2h;                               //   .
    }
    assert ((CBNL)p1h >= 0);                    //  .
    if (p1 [0] >= 0) p1 [1] = p1h;              //  .
    else             p1 [1] = -(CBNL)p1h;       //   .
    p1 [0] = 1;                                 //    .
    return;
  }

//           .

  {
    if ((CBNL)p1h < 0) p1h = -(CBNL)p1h;        //  .
    assert (p1h <= (unsigned CBNL)(CBNL_MIN));  //  .

#ifdef  _CBIGNUM_HARDWARE_DIV
    p1h %= p2h;                                 // .
#else //_CBIGNUM_HARDWARE_DIV
    int nb = cULongBits (p1h) - cULongBits (p2h);
    if (nb >= 0)                                //  ,  
    {                                           //     >= 0.
      p2h <<= nb;                               //  .
      do                                        //   .
      if (p1h >= p2h)                           //    
      {                                         //  ,
        p1h -= p2h;                             //   .
      }
      while ((p2h >>= 1, --nb) >= 0);           //    .
    }
#endif//_CBIGNUM_HARDWARE_DIV
    assert ((CBNL)p1h >= 0);                    //  .
    if (p1 [1] >= 0) p1 [1] = p1h;              //  .
    else             p1 [1] = -(CBNL)p1h;       //   .
  }
#endif//_CBIGNUM_SMALL_DIV
}

//================================================
//         .
//================================================

//         CBNL    .

CBNL   _CBNL_C  cLongMul (                      //  p = p1 * p2.
                        CBNL    l1,             // .
                        CBNL    l2,             // .
                        CBNL    p [2]           // .
        )                                       //   
{                                               // .
  return (p [0] = _muldCBNL (l1, l2, p + 1));
}
//          CBNL   .

unsigned
CBNL   _CBNL_C  cULongMul (                     //  p = p1 * p2.
                unsigned CBNL   l1,             //  .
                unsigned CBNL   l2,             //  .
                unsigned CBNL   p [2]           // .
        )                                       //   
{                                               // .
  return (p [0] = _umuldCBNL (l1, l2, p + 1));
}

//         CBNL,   .

CBNL   _CBNL_C  cLongMDivMod (                  //  p1 = p1 / p2
                                                //      p1 % p2.
                        CBNL    p1 [2],         // ,  .
                        CBNL    l2              // .
        )                                       //  .
{
  CBNL c1 [4]; c1 [0] = ((c1 [2] = p1 [1]) == ((c1 [1] = p1 [0]) >> (BITS-1)))?
                        1: 2;                   //   .
  CBNL c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  CBNL c  [5];                                  //   .
  EXPTR(CBNL) pp1 = EXPTRTO(CBNL,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(CBNL) pp2 = EXPTRTO(CBNL,c2,sizeof(c2)/sizeof(*c2)-1);
  EXPTR(CBNL) pp  = EXPTRTO(CBNL,c, sizeof(c) /sizeof(*c) -1);

  cBigNumberMModDiv (pp1, pp2, pp);             // .

  assert (c [0] <= 2);                          //   MIN/-1.
  p1 [0] = c [1];                               // .
  p1 [1] = c [2];                               // .

  return c1 [1];                                // .
}

//        CBNL,   .

CBNL   _CBNL_C  cLongMod (                      //  p1 % l2.
                const   CBNL    p1 [2],         // .
                        CBNL    l2              // .
        )                                       //  .
{
  CBNL c1 [4]; c1 [0] = ((c1 [2] = p1 [1]) == ((c1 [1] = p1 [0]) >> (BITS-1)))?
                        1: 2;                   //   .
  CBNL c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  EXPTR(CBNL) pp1 = EXPTRTO(CBNL,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(CBNL) pp2 = EXPTRTO(CBNL,c2,sizeof(c2)/sizeof(*c2)-1);

  cBigNumberMMod (pp1, pp2);                    // .

  return c1 [1];                                // .
}

//================================================
//         .
//================================================

//            ,
//         ,      , 
//       .       
//       2      .
//      ,    p2     p1 
//       -1,0,1,      512 M.
//
//             
//       .

void    cBigNumberPow (                         //  p1   p2.
                        EXPTR(CBNL) p1,         //    
                                                //  *p + 3.
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //   
                                                //  *p + 3.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  p [0] = 1; p [1] = 1;                         //   1.

  if (CBPTRBASE(p2)[n2] < 0)                    //  ?
  {
    cBigNumberFit (p1);                         // .
    cBigNumberMModDiv (p, p1, p1);              //   1/p1 
    if (p1 [1] + (p2 [1] & 1) < 0) p1 [1] = 1;  // abs(1/p1)  p2 .
    p [1] = p1 [1];
  }
  else if (n2 != 0)                             //     1?
  {
    p2++;                                       // .
    unsigned CBNL num = *p2++; --n2;            //   p2.
    unsigned CBNL mask = 1;                     //    num.
    for (;;)                                    //    p2.
    {
      if (num & mask)                           //   p2 .
        cBigNumberMul (p1, p, p);               //  .
      if (n2 == 0) {                            //   p2.
        if ((num >>= 1) == 0) break;            //  p2 .
      } else                                    //    p2.
        if ((mask <<= 1) == 0) {                //  num .
          num = *p2++; mask = 1; --n2;          //   p2.
        }
      cBigNumberMul (p1, p1, p1);               //  .
    }                                           //     p2.
  }
}

//              ,
//         ,       .
//               
//            .
//
//          ( 0    0 ,
//         1).
//
//             
//       .

void    cBigNumberPowMod (                      //  p1   p2.
                        EXPTR(CBNL) p1,         //    
                                                //  max (*mod * 2 + 3,
                                                //              *p1 + 2).
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) mod,        //  ( ).
                        EXPTR(CBNL) p           //   
                                                //  *mod * 2 + 3.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .

  p [0] = 1; p [1] = 1;                         //   1.

  if (p1 [(size_t)(*p1)] < 0)                   //  ?
  {
    cBigNumberNeg (p1, p1);                     //   .
    cBigNumberPowMod (p1, p2, mod, p);          // .
    if (p2 [1] & 1) cBigNumberNeg (p, p);       //   
    return;                                     //   .
  }
  assert (p1 [(size_t)(*p1)] >= 0);             //  .
  cBigNumberFit (p1);                           // .

  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  if (CBPTRBASE(p2)[n2] < 0)                    //  ?
  {
    cBigNumberMModDiv (p, p1, p1);              //   1/p1.
    p [1] = p1 [1]; cBigNumberMMod (p, mod);    //  .
    return;
  }
  assert (CBPTRBASE(p2)[n2] >= 0);              //  .
  p2++;                                         // .

//         ,    .

#ifdef  _CBIGNUM_SMALL_POWMOD
  unsigned CBNL pmh = 0;                        //    0.
  if (*CBPTRBASE(mod) == 1)                     //  .
  {
    pmh = CBPTRBASE(mod)[1];                    // .
    if ((CBNL)pmh < 0) pmh = -(CBNL)pmh;        //   
  }                                             //   0..-LONG_MIN.

//               .

  if (pmh <= 1)                                 //  .
  {
#endif//_CBIGNUM_SMALL_POWMOD
    cBigTemp cBigBuf3;                          //   .
    cBigBuf3.checkexpand (exmuladd (BITS, (size_t)(*CBPTRBASE(mod)),
                                    BITS * 3 + 1));
    EXPTR(CBNL) pmod = EXPTRTYPE(cBigBuf3);     //   .

//              0-.
//        0,    0 .

    size_t kmod = cBigNumberCopySkipLow0 (mod, pmod);
    size_t nmod = (size_t)(*pmod);                //  .

//         0.

    if (nmod == 0) { cBigNumberDiv0(); return; }

//            .

    if (pmod [nmod] < 0) nmod = cBigNumberNeg (pmod, pmod);
    cBigNumberTab (pmod);                       //   .

//       ,      .

    cBigNumberMModShlTab (p1, pmod, kmod);      //  .

//       .   -  0   1
//           0.

    p [1] = (nmod + kmod != 1 || pmod [nmod] != 1);

//             .

    if (n2)                                     //    p2?
    {
      unsigned CBNL num = *p2++; --n2;          //   p2.
      unsigned CBNL mask = 1;                   //    num.
      for (;;)                                  //    p2.
      {
        if (num & mask)                         //   p2 .
        {
          cBigNumberMul (p1, p, p);             //  .
          cBigNumberMModShlTab (p, pmod, kmod); //  .
        }
        if (n2 == 0) {                          //   p2.
          if ((num >>= 1) == 0) break;          //  p2 .
        } else                                  //    p2.
          if ((mask <<= 1) == 0) {              //  num .
            num = *p2++; mask = 1; --n2;        //   p2.
          }
        cBigNumberMul (p1, p1, p1);             //  .
        cBigNumberMModShlTab (p1, pmod, kmod);  //   .
      }                                         //     p2.
    }
#ifdef  _CBIGNUM_SMALL_POWMOD
  }
  else                                          //   > 1.
  {
    assert (pmh > 1 && pmh <= (unsigned CBNL)(CBNL_MIN));

//       ,      ,   .

    cBigNumberMMod (p1, mod);                   //  .
    unsigned CBNL p1h = p1 [1];                 //  .
    unsigned CBNL ph = 1; /* (pmh > 1) */       //  .

//           .  2..-CBNL_MIN.

    if (n2)                                     //    p2?
    {
      unsigned CBNL num = *p2++; --n2;          //   p2.
      unsigned CBNL mask = 1;                   //    num.

//             
//           .    
//           ,   
//       -CBNL_MIN,   cLongBits  1  0.
//        1..BITS-2.

      unsigned CBNC nb = BITS - (unsigned CBNC)cLongBits (pmh);

//        - ,   .
//        ,  .

#ifdef _CBIGNUM_HARDWARE_DIV
      if (nb >= BITS/2)                         //   -:
      {                                         //  .
        for (;;)                                //    p2.
        {
          if (num & mask)                       //   p2 .
          {
            ph *= p1h; ph %= pmh;               //  .
          }
          if (n2 == 0) {                        //   p2.
            if ((num >>= 1) == 0) break;        //  p2 .
          } else                                //    p2.
            if ((mask <<= 1) == 0) {            //  num .
              num = *p2++; mask = 1; --n2;      //   p2.
            }
          p1h *= p1h; p1h %= pmh;               //   .
        }                                       //     p2.
      }
      else if (nb >= _CBNL_HARDDIV_BITS)        //   
      {                                         //   .
        unsigned CBNL pm = pmh;                 //   .
        pmh <<= (nb - 1);                       //   
        assert (cLongBits (pmh) == BITS-1);     //  .
        nb = nb + nb - 1;                       //   .
        for (;;)                                //    p2.
        {
          if (num & mask)                       //   p2 .
          {                                     //  .
            unsigned CBNL pp;                   //    .
            ph = _umuldCBNL (p1h, ph, &pp);     //  .
            unsigned CBNL pl = ph << nb;        //   .
            ph = _ushldCBNL (ph, pp, nb);       //   .
            unsigned CBNC nbb = nb - BITS;      //   .
            do                                  //  :
            {                                   //    
              if (ph >= pmh) ph -= pmh;         // ,  .
              _USHLD1CBNL (pl, ph);             //  ,  
            }                                   //    BITS.
            while (++nbb);
            ph %= pm;                           //  .
          }
          if (n2 == 0) {                        //   p2.
            if ((num >>= 1) == 0) break;        //  p2 .
          } else                                //    p2.
            if ((mask <<= 1) == 0) {            //  num .
              num = *p2++; mask = 1; --n2;      //   p2.
            }
          {
            unsigned CBNL pp;                   //    .
            p1h = _umuldCBNL (p1h, p1h, &pp);   //  .
            unsigned CBNL p1l = p1h << nb;      //   .
            p1h = _ushldCBNL (p1h, pp, nb);     //   .
            unsigned CBNC nbb = nb - BITS;      //   .
            do                                  //  :
            {                                   //    
              if (p1h >= pmh) p1h -= pmh;       // ,  .
              _USHLD1CBNL (p1l, p1h);           //  ,  
            }                                   //    BITS.
            while (++nbb);
            p1h %= pm;                          //  .
          }
        }                                       //     p2.
      }
      else                                      //   .
#endif//_CBIGNUM_HARDWARE_DIV
      {
        for (;;)                                //    p2.
        {
          if (num & mask)                       //   p2 .
          {                                     //  .
            unsigned CBNL pp;                   //    .
            ph = _umuldCBNL (p1h, ph, &pp);     //  .
            unsigned CBNL pl = ph << nb;        //   .
            ph = _ushldCBNL (ph, pp, nb);       //   .
            unsigned CBNC nbb = nb - BITS - 1;  //   .
            for (;;)                            //  :
            {                                   //    
              if (ph >= pmh) ph -= pmh;         // ,  .
              if (!++nbb) break;                //  ,  
              _USHLD1CBNL (pl, ph);             //    BITS.
            }
          }
          if (n2 == 0) {                        //   p2.
            if ((num >>= 1) == 0) break;        //  p2 .
          } else                                //    p2.
            if ((mask <<= 1) == 0) {            //  num .
              num = *p2++; mask = 1; --n2;      //   p2.
            }
          {
            unsigned CBNL pp;                   //    .
            p1h = _umuldCBNL (p1h, p1h, &pp);   //  .
            unsigned CBNL p1l = p1h << nb;      //   .
            p1h = _ushldCBNL (p1h, pp, nb);     //   .
            unsigned CBNC nbb = nb - BITS - 1;  //   .
            for (;;)                            //  :
            {                                   //    
              if (p1h >= pmh) p1h -= pmh;       // ,  .
              if (!++nbb) break;                //  ,  
              _USHLD1CBNL (p1l, p1h);           //    BITS.
            }
          }
        }                                       //     p2.
      }
    }
    assert (ph < pmh);                          // .
    p [1] = ph;                                 // .
  }
#endif//_CBIGNUM_SMALL_POWMOD
}

//================================================
//         .
//================================================

//          
//           .
//         > CBNL_MAX  cBigNumberERange().
//
//         .
//            .

void    cBigNumberMRmSqrt (                     //  .
                        EXPTR(CBNL) p1,         // ,  .
                        EXPTR(CBNL) p           //   *p1/2 + 2.
        )                                       // p1, p   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  assert (p1 [n1] >= 0);                        //  .

  cBigTemp cBigBuf2;                            //   .
  cBigBuf2.checkexpand (n1 + 1);                // +1   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .
  *pp2 = 0;                                     // .
  cBigNumberFitTo (pp2, n1);                    // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

//      .

  CBNL nbit = (cBigNumberBits (p1) + 1) & ~1;
  if ((nbit -= 2) >= 0)
  {

//         .

    {
      size_t nw = (size_t)(nbit / BITS);        // .
      CBNL lw = (((CBNL)1) << (nbit % BITS));   // .
      pp2 [nw + 1] += lw;                       //  .
      assert (pp2 [(size_t)(*pp2)] >= 0);       //  .
      p1  [nw + 1] -= lw;                       //   .
      assert (p1  [(size_t)(*p1)]  >= 0);       //  .
    }

//         .
//           ,  
//          .

    while ((nbit -= 2) >= 0)                    //    .
    {
      size_t nw = (size_t)(nbit / BITS);        // .
      CBNL lw = (((CBNL)1) << (nbit % BITS));   // .
      pp2 [nw + 1] += lw;                       //  .
      if (cBigNumberComp (p1, pp2) < 0)         // .
      {
        pp2 [nw] = (CBNL)(n1 - nw);             //   0-.
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2 + nw);            //    .
      }
      else
      {
        pp2 [nw] = (CBNL)(n1 - nw);             //   0-.
        cBigNumberMSubD (p1, pp2 + nw, nw);     //  .
        assert (p1 [(size_t)(*p1)] >= 0);       //  .
        assert (cBigNumberIsFit (p1));          //  .
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2 + nw);            //    .
        pp2 [nw + 1] += lw;                     //  .
      }
      n1 = (size_t)(pp2 [nw] + nw);             //  
      pp2 [nw] = 0;                             //   
      pp2 [0] = (CBNL)n1;                       //   0-.
      assert (pp2 [(size_t)(*pp2)] >= 0);       //  .
      assert (cBigNumberIsFit (pp2));           //  .
    }
  }

  cBigNumberFit (pp2);                          //  .
  cBigNumberCopy (pp2, p);                      //  .

//      ,      ,
//           .

  assert (cBigNumberComp ((cBigNumberMMul2M (pp2), pp2), p1) >= 0);
}

//================================================
//        .
//================================================

//         , 
//           
//        0..ULONG_MAX.
//
//           
//             .

void    cBigNumberRandom (                      //  .
                unsigned long (*pfnRand)(),     //   .
                unsigned CBNL lBits,            //   .
                        EXPTR(CBNL) p           //   lBits/BITS+1.
        )
{
  CBNL   l1 = lBits % BITS;                     //  .
  size_t n1 = (size_t)(lBits / BITS + 1);       //  .

  if (l1 != 0) l1 = cLongRandom (*pfnRand) &
                    ((unsigned CBNL)~0L >> (BITS-(size_t)l1));
  p [0] = (CBNL)n1;                             //  .
  p [n1] = l1;                                  //  .
  while (--n1 != 0) p [n1] = cLongRandom (*pfnRand);
                                                //  .
  cBigNumberFit (p);                            // .
  assert (p [(size_t)(*p)] >= 0);               //  .
}

//         CBNL  
//       ,

#if UCBNL_MAX > ULONG_MAX                       // Inline  CBNL long.

#define LBITS   (CHAR_BIT * sizeof (long))

unsigned CBNL _CBNL_C cLongRandom (             //  .
                unsigned long (*pfnRand)()      //   .
)                                               //   .
{
  unsigned CBNL temp = (*pfnRand)();
  int sh = LBITS; do temp |= (((CBNL)(*pfnRand)()) << LBITS); while ((sh += LBITS) < BITS);
  return (temp);
}

#endif

#ifdef  NCHECKPTR
#ifdef  __cplusplus
}
#endif//__cplusplus
#endif//NCHECKPTR

#endif//_CBIGNUMF_INL
